﻿/***************** 
 * Showcoin Test *
 *****************/

import { PsychoJS } from './lib/core-2021.1.0.js';
import * as core from './lib/core-2021.1.0.js';
import { TrialHandler } from './lib/data-2021.1.0.js';
import { Scheduler } from './lib/util-2021.1.0.js';
import * as visual from './lib/visual-2021.1.0.js';
import * as sound from './lib/sound-2021.1.0.js';
import * as util from './lib/util-2021.1.0.js';
//some handy aliases as in the psychopy scripts;
const { abs, sin, cos, PI: pi, sqrt } = Math;
const { round } = util;

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});

// store info about the experiment session:
let expName = 'showCoin';  // from the Builder filename that created this script
let expInfo = {'participant': '16', 'age': '', 'gender': '', 'session': '1', 'ProlificID': '{{%PROLIFIC_PID%}}', 'StudyID': '{{%STUDY_ID%}}', 'SessionID': '{{%SESSION_ID%}}'};

// Start code blocks for 'Before Experiment'
thisExp=psychoJS.experiment;
gains = 0;
gains = 0;
// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(Instr_1bRoutineBegin());
flowScheduler.add(Instr_1bRoutineEachFrame());
flowScheduler.add(Instr_1bRoutineEnd());
flowScheduler.add(InstrVisual3bRoutineBegin());
flowScheduler.add(InstrVisual3bRoutineEachFrame());
flowScheduler.add(InstrVisual3bRoutineEnd());
const trials_0abLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trials_0abLoopBegin, trials_0abLoopScheduler);
flowScheduler.add(trials_0abLoopScheduler);
flowScheduler.add(trials_0abLoopEnd);
const conditions_1and2LoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(conditions_1and2LoopBegin, conditions_1and2LoopScheduler);
flowScheduler.add(conditions_1and2LoopScheduler);
flowScheduler.add(conditions_1and2LoopEnd);
const conditions_3and4LoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(conditions_3and4LoopBegin, conditions_3and4LoopScheduler);
flowScheduler.add(conditions_3and4LoopScheduler);
flowScheduler.add(conditions_3and4LoopEnd);
flowScheduler.add(End_screenRoutineBegin());
flowScheduler.add(End_screenRoutineEachFrame());
flowScheduler.add(End_screenRoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  });

psychoJS.experimentLogger.setLevel(core.Logger.ServerLevel.DEBUG);


var frameDur;
function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2021.1.0';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  psychoJS.setRedirectUrls('https://nottinghampsych.eu.qualtrics.com/jfe/form/SV_0eaOrlCnAOmYWON ', '');

  return Scheduler.Event.NEXT;
}


var Instr_1bClock;
var thisExp;
var green;
var white;
var text_9;
var instr_resp_2;
var group;
var conditions;
var xlsx;
var condition1;
var condition2;
var InstrVisual3bClock;
var text_12;
var key_resp_instr3_3;
var condition0_trial1Clock;
var cue_coin_13;
var mouse_14;
var confirm_net_13;
var fixation_13;
var net_posx;
var net_posy;
var net_shape_13;
var condition0_trial2Clock;
var target_coin_3;
var cue_coin_14;
var net_posx2;
var net_posy2;
var net_shape_14;
var mouse_15;
var fixation_14;
var confirm_net_14;
var feedback_net_posx;
var feedback_net_posy;
var feedback_color;
var border_color;
var net_shape_feedback_7;
var score_text_6;
var condition_order1Clock;
var text_6;
var key_resp;
var cond1_trialClock;
var cue_coin;
var mouse;
var confirm_net;
var fixation;
var net_shape;
var cond1_trial_2Clock;
var target_coin_2;
var cue_coin_2;
var net_shape_2;
var mouse_2;
var fixation_2;
var confirm_net_2;
var gains;
var net_shape_feedback;
var score_text_2;
var BreakScreenClock;
var break_text;
var break_resp;
var cond2_trial1Clock;
var cue_coin_3;
var mouse_4;
var confirm_net_3;
var fixation_3;
var net_shape_3;
var cond2_trial_2Clock;
var target_coin_4;
var cue_coin_4;
var net_shape_4;
var mouse_5;
var fixation_4;
var confirm_net_4;
var net_shape_feedback_2;
var score_text_3;
var condition_order2Clock;
var text_7;
var key_resp_2;
var cond3_trial1Clock;
var cue_coin_5;
var mouse_6;
var confirm_net_6;
var fixation_5;
var net_shape_5;
var cond3_trial2Clock;
var target_coin_6;
var cue_coin_6;
var net_shape_6;
var mouse_7;
var fixation_6;
var confirm_net_5;
var net_shape_feedback_3;
var score_text_4;
var cond4_trial1Clock;
var cue_coin_7;
var mouse_8;
var confirm_net_7;
var fixation_7;
var net_shape_7;
var cond4_trial2Clock;
var target_coin_8;
var cue_coin_8;
var net_shape_8;
var mouse_9;
var fixation_8;
var confirm_net_8;
var net_shape_feedback_4;
var score_text_5;
var End_screenClock;
var text_10;
var key_resp_3;
var globalClock;
var routineTimer;
function experimentInit() {
  // Initialize components for Routine "Instr_1b"
  Instr_1bClock = new util.Clock();
  thisExp = psychoJS.experiment;
  green = new util.Color([-1, 0, -1]);
  white = new util.Color([0, 0, 0]);
  text_9 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_9',
    text: '\nWelcome to the fourth session. It will last for 30 minutes.\n\nPress space to continue.\n\n',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -1.0 
  });
  
  instr_resp_2 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  group = "AB";
  conditions = "conditions";
  xlsx = ".xlsx";
  group = "AB";
  condition1 = "Press space to begin the second condition";
  condition2 = "Press space to begin the third condition";
  
  // Initialize components for Routine "InstrVisual3b"
  InstrVisual3bClock = new util.Clock();
  text_12 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_12',
    text: '\n\n\nPress space to begin the first condition.',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  key_resp_instr3_3 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "condition0_trial1"
  condition0_trial1Clock = new util.Clock();
  cue_coin_13 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_13', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  mouse_14 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_14.mouseClock = new util.Clock();
  confirm_net_13 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  fixation_13 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_13', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  net_posx = 0;
  net_posy = 0;
  
  
  
  net_shape_13 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_13', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "condition0_trial2"
  condition0_trial2Clock = new util.Clock();
  target_coin_3 = new visual.Polygon ({
    win: psychoJS.window, name: 'target_coin_3', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 0, 0]),
    fillColor: new util.Color([1, 0, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  cue_coin_14 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_14', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -2, interpolate: true,
  });
  
  net_posx2 = 0;
  net_posy2 = 0;
  net_shape_14 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_14', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1.0, depth: -4, interpolate: true,
  });
  
  mouse_15 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_15.mouseClock = new util.Clock();
  fixation_14 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_14', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  confirm_net_14 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  feedback_net_posx = 0;
  feedback_net_posy  = 0; //for defining the builder component position at the start then code takes over
  white = new util.Color([1, 1, 1]);
  green = new util.Color([-1, 0, -1]);
  feedback_color = white;
  border_color = white;
  
  
  
  
  
  net_shape_feedback_7 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_feedback_7', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1.0, lineColor: new util.Color('white'),
    fillColor: new util.Color('white'),
    opacity: 1.0, depth: -9, interpolate: true,
  });
  
  score_text_6 = new visual.TextStim({
    win: psychoJS.window,
    name: 'score_text_6',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.4, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "condition_order1"
  condition_order1Clock = new util.Clock();
  text_6 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_6',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  condition1 = "Press space to begin the second condition";
  condition2 = "Press space to begin the third condition";
  
  // Initialize components for Routine "cond1_trial"
  cond1_trialClock = new util.Clock();
  cue_coin = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  mouse = new core.Mouse({
    win: psychoJS.window,
  });
  mouse.mouseClock = new util.Clock();
  confirm_net = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  fixation = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  net_posx = 0;
  net_posy = 0;
  
  
  
  net_shape = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "cond1_trial_2"
  cond1_trial_2Clock = new util.Clock();
  target_coin_2 = new visual.Polygon ({
    win: psychoJS.window, name: 'target_coin_2', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 0, 0]),
    fillColor: new util.Color([1, 0, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  cue_coin_2 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_2', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -2, interpolate: true,
  });
  
  net_posx2 = 0;
  net_posy2 = 0;
  
  
  net_shape_2 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_2', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1.0, depth: -4, interpolate: true,
  });
  
  mouse_2 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_2.mouseClock = new util.Clock();
  fixation_2 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_2', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  confirm_net_2 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  feedback_net_posx = mouse.getPos()[0];
  feedback_net_posy  = mouse.getPos()[1]; //for defining the builder component position at the start then code takes over
  white = new util.Color([1, 1, 1]);
  green = new util.Color([-1, 0, -1]);
  feedback_color = white;
  border_color = white;
  
  gains = 0;
  
  
  net_shape_feedback = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_feedback', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1.0, lineColor: new util.Color('white'),
    fillColor: new util.Color('white'),
    opacity: 1.0, depth: -9, interpolate: true,
  });
  
  score_text_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'score_text_2',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.4, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "BreakScreen"
  BreakScreenClock = new util.Clock();
  break_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'break_text',
    text: '\n\n\nThis is a short break.\n\nPress space when you are ready to continue.\n',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  break_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "cond2_trial1"
  cond2_trial1Clock = new util.Clock();
  cue_coin_3 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_3', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  mouse_4 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_4.mouseClock = new util.Clock();
  confirm_net_3 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  fixation_3 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_3', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  net_posx = 0;
  net_posy = 0;
  
  net_shape_3 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_3', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "cond2_trial_2"
  cond2_trial_2Clock = new util.Clock();
  target_coin_4 = new visual.Polygon ({
    win: psychoJS.window, name: 'target_coin_4', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 0, 0]),
    fillColor: new util.Color([1, 0, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  cue_coin_4 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_4', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -2, interpolate: true,
  });
  
  net_posx2 = 0;
  net_posy2 = 0;
  
  net_shape_4 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_4', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  mouse_5 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_5.mouseClock = new util.Clock();
  fixation_4 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_4', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  confirm_net_4 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  feedback_net_posx = mouse.getPos()[0];
  feedback_net_posy  = mouse.getPos()[1]; //for defining the builder component position at the start then code takes over
  
  white = new util.Color([1, 1, 1]);
  green = new util.Color([-1, 0, -1]);
  feedback_color = white;
  border_color = white;
  
  
  
  net_shape_feedback_2 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_feedback_2', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color('white'),
    fillColor: new util.Color('white'),
    opacity: 0.7, depth: -9, interpolate: true,
  });
  
  score_text_3 = new visual.TextStim({
    win: psychoJS.window,
    name: 'score_text_3',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.4, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "condition_order2"
  condition_order2Clock = new util.Clock();
  text_7 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_7',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp_2 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "cond3_trial1"
  cond3_trial1Clock = new util.Clock();
  cue_coin_5 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_5', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  mouse_6 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_6.mouseClock = new util.Clock();
  confirm_net_6 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  fixation_5 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_5', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  net_posx = 0;
  net_posy = 0;
  
  net_shape_5 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_5', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "cond3_trial2"
  cond3_trial2Clock = new util.Clock();
  target_coin_6 = new visual.Polygon ({
    win: psychoJS.window, name: 'target_coin_6', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 0, 0]),
    fillColor: new util.Color([1, 0, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  cue_coin_6 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_6', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -2, interpolate: true,
  });
  
  net_posx2 = 0;
  net_posy2 = 0;
  
  net_shape_6 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_6', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  mouse_7 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_7.mouseClock = new util.Clock();
  fixation_6 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_6', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  confirm_net_5 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  feedback_net_posx = 0;
  feedback_net_posy  = 0; //for defining the builder component position at the start then code takes over
  
  white = new util.Color([1, 1, 1]);
  green = new util.Color([-1, 0, -1]);
  feedback_color = white;
  border_color = white;
  
  
  net_shape_feedback_3 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_feedback_3', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color('white'),
    fillColor: new util.Color('white'),
    opacity: 0.7, depth: -9, interpolate: true,
  });
  
  score_text_4 = new visual.TextStim({
    win: psychoJS.window,
    name: 'score_text_4',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.4, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "BreakScreen"
  BreakScreenClock = new util.Clock();
  break_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'break_text',
    text: '\n\n\nThis is a short break.\n\nPress space when you are ready to continue.\n',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  break_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "cond4_trial1"
  cond4_trial1Clock = new util.Clock();
  cue_coin_7 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_7', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  mouse_8 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_8.mouseClock = new util.Clock();
  confirm_net_7 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  fixation_7 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_7', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  net_posx = 0;
  net_posy = 0;
  
  net_shape_7 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_7', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  // Initialize components for Routine "cond4_trial2"
  cond4_trial2Clock = new util.Clock();
  target_coin_8 = new visual.Polygon ({
    win: psychoJS.window, name: 'target_coin_8', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 0, 0]),
    fillColor: new util.Color([1, 0, 0]),
    opacity: 1, depth: -1, interpolate: true,
  });
  
  cue_coin_8 = new visual.Polygon ({
    win: psychoJS.window, name: 'cue_coin_8', units : 'height', 
    edges: 200, size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 0]),
    fillColor: new util.Color([1, 1, 0]),
    opacity: 1, depth: -2, interpolate: true,
  });
  
  net_posx2 = 0;
  net_posy2 = 0;
  
  net_shape_8 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_8', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -4, interpolate: true,
  });
  
  mouse_9 = new core.Mouse({
    win: psychoJS.window,
  });
  mouse_9.mouseClock = new util.Clock();
  fixation_8 = new visual.ShapeStim ({
    win: psychoJS.window, name: 'fixation_8', 
    vertices: 'cross', size:[0.05, 0.05],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color([1, 1, 1]),
    fillColor: new util.Color([1, 1, 1]),
    opacity: 1, depth: -6, interpolate: true,
  });
  
  confirm_net_8 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  feedback_net_posx = mouse.getPos()[0];
  feedback_net_posy  = mouse.getPos()[1]; //for defining the builder component position at the start then code takes over
  
  white = new util.Color([1, 1, 1]);
  green = new util.Color([-1, 0, -1]);
  feedback_color = white;
  border_color = white;
  net_shape_feedback_4 = new visual.Rect ({
    win: psychoJS.window, name: 'net_shape_feedback_4', units : 'height', 
    width: [0.07, 10][0], height: [0.07, 10][1],
    ori: 0, pos: [0, 0],
    lineWidth: 1, lineColor: new util.Color('white'),
    fillColor: new util.Color('white'),
    opacity: 0.7, depth: -9, interpolate: true,
  });
  
  score_text_5 = new visual.TextStim({
    win: psychoJS.window,
    name: 'score_text_5',
    text: 'default text',
    font: 'Open Sans',
    units: undefined, 
    pos: [0.4, 0.4], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: -10.0 
  });
  
  // Initialize components for Routine "End_screen"
  End_screenClock = new util.Clock();
  text_10 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_10',
    text: '\n\nThank you for taking part.\nPress space to be directed to the debrief and subsequently able to claim your inconvenience allowance.',
    font: 'Open Sans',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0.0,
    color: new util.Color('white'),  opacity: undefined,
    depth: 0.0 
  });
  
  key_resp_3 = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var continueRoutine;
var _instr_resp_2_allKeys;
var Instr_1bComponents;
function Instr_1bRoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'Instr_1b'-------
    t = 0;
    Instr_1bClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    instr_resp_2.keys = undefined;
    instr_resp_2.rt = undefined;
    _instr_resp_2_allKeys = [];
    // keep track of which components have finished
    Instr_1bComponents = [];
    Instr_1bComponents.push(text_9);
    Instr_1bComponents.push(instr_resp_2);
    
    for (const thisComponent of Instr_1bComponents)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function Instr_1bRoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'Instr_1b'-------
    // get current time
    t = Instr_1bClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_9* updates
    if (t >= 0.0 && text_9.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_9.tStart = t;  // (not accounting for frame time here)
      text_9.frameNStart = frameN;  // exact frame index
      
      text_9.setAutoDraw(true);
    }

    
    // *instr_resp_2* updates
    if (t >= 0.0 && instr_resp_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instr_resp_2.tStart = t;  // (not accounting for frame time here)
      instr_resp_2.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { instr_resp_2.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { instr_resp_2.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { instr_resp_2.clearEvents(); });
    }

    if (instr_resp_2.status === PsychoJS.Status.STARTED) {
      let theseKeys = instr_resp_2.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _instr_resp_2_allKeys = _instr_resp_2_allKeys.concat(theseKeys);
      if (_instr_resp_2_allKeys.length > 0) {
        instr_resp_2.keys = _instr_resp_2_allKeys[_instr_resp_2_allKeys.length - 1].name;  // just the last key pressed
        instr_resp_2.rt = _instr_resp_2_allKeys[_instr_resp_2_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of Instr_1bComponents)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function Instr_1bRoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'Instr_1b'-------
    for (const thisComponent of Instr_1bComponents) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('instr_resp_2.keys', instr_resp_2.keys);
    if (typeof instr_resp_2.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('instr_resp_2.rt', instr_resp_2.rt);
        routineTimer.reset();
        }
    
    instr_resp_2.stop();
    // the Routine "Instr_1b" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _key_resp_instr3_3_allKeys;
var InstrVisual3bComponents;
function InstrVisual3bRoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'InstrVisual3b'-------
    t = 0;
    InstrVisual3bClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp_instr3_3.keys = undefined;
    key_resp_instr3_3.rt = undefined;
    _key_resp_instr3_3_allKeys = [];
    // keep track of which components have finished
    InstrVisual3bComponents = [];
    InstrVisual3bComponents.push(text_12);
    InstrVisual3bComponents.push(key_resp_instr3_3);
    
    for (const thisComponent of InstrVisual3bComponents)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function InstrVisual3bRoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'InstrVisual3b'-------
    // get current time
    t = InstrVisual3bClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_12* updates
    if (t >= 0.0 && text_12.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_12.tStart = t;  // (not accounting for frame time here)
      text_12.frameNStart = frameN;  // exact frame index
      
      text_12.setAutoDraw(true);
    }

    
    // *key_resp_instr3_3* updates
    if (t >= 1.0 && key_resp_instr3_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_instr3_3.tStart = t;  // (not accounting for frame time here)
      key_resp_instr3_3.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_instr3_3.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_instr3_3.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_instr3_3.clearEvents(); });
    }

    if (key_resp_instr3_3.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_instr3_3.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _key_resp_instr3_3_allKeys = _key_resp_instr3_3_allKeys.concat(theseKeys);
      if (_key_resp_instr3_3_allKeys.length > 0) {
        key_resp_instr3_3.keys = _key_resp_instr3_3_allKeys[_key_resp_instr3_3_allKeys.length - 1].name;  // just the last key pressed
        key_resp_instr3_3.rt = _key_resp_instr3_3_allKeys[_key_resp_instr3_3_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of InstrVisual3bComponents)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function InstrVisual3bRoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'InstrVisual3b'-------
    for (const thisComponent of InstrVisual3bComponents) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('key_resp_instr3_3.keys', key_resp_instr3_3.keys);
    if (typeof key_resp_instr3_3.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_instr3_3.rt', key_resp_instr3_3.rt);
        routineTimer.reset();
        }
    
    key_resp_instr3_3.stop();
    // the Routine "InstrVisual3b" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var trials_0ab;
var currentLoop;
function trials_0abLoopBegin(trials_0abLoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_0ab = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: '0.01_CueSD_walk.xlsx',
    seed: undefined, name: 'trials_0ab'
  });
  psychoJS.experiment.addLoop(trials_0ab); // add the loop to the experiment
  currentLoop = trials_0ab;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrials_0ab of trials_0ab) {
    const snapshot = trials_0ab.getSnapshot();
    trials_0abLoopScheduler.add(importConditions(snapshot));
    const trialsLoopScheduler = new Scheduler(psychoJS);
    trials_0abLoopScheduler.add(trialsLoopBegin, trialsLoopScheduler);
    trials_0abLoopScheduler.add(trialsLoopScheduler);
    trials_0abLoopScheduler.add(trialsLoopEnd);
    const trials_0LoopScheduler = new Scheduler(psychoJS);
    trials_0abLoopScheduler.add(trials_0LoopBegin, trials_0LoopScheduler);
    trials_0abLoopScheduler.add(trials_0LoopScheduler);
    trials_0abLoopScheduler.add(trials_0LoopEnd);
    trials_0abLoopScheduler.add(endLoopIteration(trials_0abLoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


var trials;
function trialsLoopBegin(trialsLoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond0_Trial1,
    seed: undefined, name: 'trials'
  });
  psychoJS.experiment.addLoop(trials); // add the loop to the experiment
  currentLoop = trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial of trials) {
    const snapshot = trials.getSnapshot();
    trialsLoopScheduler.add(importConditions(snapshot));
    trialsLoopScheduler.add(condition0_trial1RoutineBegin(snapshot));
    trialsLoopScheduler.add(condition0_trial1RoutineEachFrame(snapshot));
    trialsLoopScheduler.add(condition0_trial1RoutineEnd(snapshot));
    trialsLoopScheduler.add(endLoopIteration(trialsLoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


var trials_0;
function trials_0LoopBegin(trials_0LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_0 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond0_Trial2andBeyond,
    seed: undefined, name: 'trials_0'
  });
  psychoJS.experiment.addLoop(trials_0); // add the loop to the experiment
  currentLoop = trials_0;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_0 of trials_0) {
    const snapshot = trials_0.getSnapshot();
    trials_0LoopScheduler.add(importConditions(snapshot));
    trials_0LoopScheduler.add(condition0_trial2RoutineBegin(snapshot));
    trials_0LoopScheduler.add(condition0_trial2RoutineEachFrame(snapshot));
    trials_0LoopScheduler.add(condition0_trial2RoutineEnd(snapshot));
    trials_0LoopScheduler.add(endLoopIteration(trials_0LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_0LoopEnd() {
  psychoJS.experiment.removeLoop(trials_0);

  return Scheduler.Event.NEXT;
}


function trials_0abLoopEnd() {
  psychoJS.experiment.removeLoop(trials_0ab);

  return Scheduler.Event.NEXT;
}


var conditions_1and2;
function conditions_1and2LoopBegin(conditions_1and2LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  conditions_1and2 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: 'cueSD0.05_0.1.xlsx',
    seed: undefined, name: 'conditions_1and2'
  });
  psychoJS.experiment.addLoop(conditions_1and2); // add the loop to the experiment
  currentLoop = conditions_1and2;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisConditions_1and2 of conditions_1and2) {
    const snapshot = conditions_1and2.getSnapshot();
    conditions_1and2LoopScheduler.add(importConditions(snapshot));
    const trials_1LoopScheduler = new Scheduler(psychoJS);
    conditions_1and2LoopScheduler.add(trials_1LoopBegin, trials_1LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_1LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_1LoopEnd);
    const trials_2LoopScheduler = new Scheduler(psychoJS);
    conditions_1and2LoopScheduler.add(trials_2LoopBegin, trials_2LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_2LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_2LoopEnd);
    conditions_1and2LoopScheduler.add(BreakScreenRoutineBegin(snapshot));
    conditions_1and2LoopScheduler.add(BreakScreenRoutineEachFrame(snapshot));
    conditions_1and2LoopScheduler.add(BreakScreenRoutineEnd(snapshot));
    const trials_7LoopScheduler = new Scheduler(psychoJS);
    conditions_1and2LoopScheduler.add(trials_7LoopBegin, trials_7LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_7LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_7LoopEnd);
    const trials_3LoopScheduler = new Scheduler(psychoJS);
    conditions_1and2LoopScheduler.add(trials_3LoopBegin, trials_3LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_3LoopScheduler);
    conditions_1and2LoopScheduler.add(trials_3LoopEnd);
    conditions_1and2LoopScheduler.add(endLoopIteration(conditions_1and2LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


var trials_1;
function trials_1LoopBegin(trials_1LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_1 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond5Trial1,
    seed: undefined, name: 'trials_1'
  });
  psychoJS.experiment.addLoop(trials_1); // add the loop to the experiment
  currentLoop = trials_1;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_1 of trials_1) {
    const snapshot = trials_1.getSnapshot();
    trials_1LoopScheduler.add(importConditions(snapshot));
    trials_1LoopScheduler.add(condition_order1RoutineBegin(snapshot));
    trials_1LoopScheduler.add(condition_order1RoutineEachFrame(snapshot));
    trials_1LoopScheduler.add(condition_order1RoutineEnd(snapshot));
    trials_1LoopScheduler.add(cond1_trialRoutineBegin(snapshot));
    trials_1LoopScheduler.add(cond1_trialRoutineEachFrame(snapshot));
    trials_1LoopScheduler.add(cond1_trialRoutineEnd(snapshot));
    trials_1LoopScheduler.add(endLoopIteration(trials_1LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_1LoopEnd() {
  psychoJS.experiment.removeLoop(trials_1);

  return Scheduler.Event.NEXT;
}


var trials_2;
function trials_2LoopBegin(trials_2LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_2 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond5Trial2andBeyond,
    seed: undefined, name: 'trials_2'
  });
  psychoJS.experiment.addLoop(trials_2); // add the loop to the experiment
  currentLoop = trials_2;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_2 of trials_2) {
    const snapshot = trials_2.getSnapshot();
    trials_2LoopScheduler.add(importConditions(snapshot));
    trials_2LoopScheduler.add(cond1_trial_2RoutineBegin(snapshot));
    trials_2LoopScheduler.add(cond1_trial_2RoutineEachFrame(snapshot));
    trials_2LoopScheduler.add(cond1_trial_2RoutineEnd(snapshot));
    trials_2LoopScheduler.add(endLoopIteration(trials_2LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_2LoopEnd() {
  psychoJS.experiment.removeLoop(trials_2);

  return Scheduler.Event.NEXT;
}


var trials_7;
function trials_7LoopBegin(trials_7LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_7 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond6Trial1,
    seed: undefined, name: 'trials_7'
  });
  psychoJS.experiment.addLoop(trials_7); // add the loop to the experiment
  currentLoop = trials_7;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_7 of trials_7) {
    const snapshot = trials_7.getSnapshot();
    trials_7LoopScheduler.add(importConditions(snapshot));
    trials_7LoopScheduler.add(cond2_trial1RoutineBegin(snapshot));
    trials_7LoopScheduler.add(cond2_trial1RoutineEachFrame(snapshot));
    trials_7LoopScheduler.add(cond2_trial1RoutineEnd(snapshot));
    trials_7LoopScheduler.add(endLoopIteration(trials_7LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_7LoopEnd() {
  psychoJS.experiment.removeLoop(trials_7);

  return Scheduler.Event.NEXT;
}


var trials_3;
function trials_3LoopBegin(trials_3LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_3 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond6Trial2andBeyond,
    seed: undefined, name: 'trials_3'
  });
  psychoJS.experiment.addLoop(trials_3); // add the loop to the experiment
  currentLoop = trials_3;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_3 of trials_3) {
    const snapshot = trials_3.getSnapshot();
    trials_3LoopScheduler.add(importConditions(snapshot));
    trials_3LoopScheduler.add(cond2_trial_2RoutineBegin(snapshot));
    trials_3LoopScheduler.add(cond2_trial_2RoutineEachFrame(snapshot));
    trials_3LoopScheduler.add(cond2_trial_2RoutineEnd(snapshot));
    trials_3LoopScheduler.add(endLoopIteration(trials_3LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_3LoopEnd() {
  psychoJS.experiment.removeLoop(trials_3);

  return Scheduler.Event.NEXT;
}


function conditions_1and2LoopEnd() {
  psychoJS.experiment.removeLoop(conditions_1and2);

  return Scheduler.Event.NEXT;
}


var conditions_3and4;
function conditions_3and4LoopBegin(conditions_3and4LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  conditions_3and4 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: 'cueSD0.15_0.2.xlsx',
    seed: undefined, name: 'conditions_3and4'
  });
  psychoJS.experiment.addLoop(conditions_3and4); // add the loop to the experiment
  currentLoop = conditions_3and4;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisConditions_3and4 of conditions_3and4) {
    const snapshot = conditions_3and4.getSnapshot();
    conditions_3and4LoopScheduler.add(importConditions(snapshot));
    const trials_4LoopScheduler = new Scheduler(psychoJS);
    conditions_3and4LoopScheduler.add(trials_4LoopBegin, trials_4LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_4LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_4LoopEnd);
    const trials_5LoopScheduler = new Scheduler(psychoJS);
    conditions_3and4LoopScheduler.add(trials_5LoopBegin, trials_5LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_5LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_5LoopEnd);
    conditions_3and4LoopScheduler.add(BreakScreenRoutineBegin(snapshot));
    conditions_3and4LoopScheduler.add(BreakScreenRoutineEachFrame(snapshot));
    conditions_3and4LoopScheduler.add(BreakScreenRoutineEnd(snapshot));
    const trials_6LoopScheduler = new Scheduler(psychoJS);
    conditions_3and4LoopScheduler.add(trials_6LoopBegin, trials_6LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_6LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_6LoopEnd);
    const trials_9LoopScheduler = new Scheduler(psychoJS);
    conditions_3and4LoopScheduler.add(trials_9LoopBegin, trials_9LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_9LoopScheduler);
    conditions_3and4LoopScheduler.add(trials_9LoopEnd);
    conditions_3and4LoopScheduler.add(endLoopIteration(conditions_3and4LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


var trials_4;
function trials_4LoopBegin(trials_4LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_4 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond3Trial1,
    seed: undefined, name: 'trials_4'
  });
  psychoJS.experiment.addLoop(trials_4); // add the loop to the experiment
  currentLoop = trials_4;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_4 of trials_4) {
    const snapshot = trials_4.getSnapshot();
    trials_4LoopScheduler.add(importConditions(snapshot));
    trials_4LoopScheduler.add(condition_order2RoutineBegin(snapshot));
    trials_4LoopScheduler.add(condition_order2RoutineEachFrame(snapshot));
    trials_4LoopScheduler.add(condition_order2RoutineEnd(snapshot));
    trials_4LoopScheduler.add(cond3_trial1RoutineBegin(snapshot));
    trials_4LoopScheduler.add(cond3_trial1RoutineEachFrame(snapshot));
    trials_4LoopScheduler.add(cond3_trial1RoutineEnd(snapshot));
    trials_4LoopScheduler.add(endLoopIteration(trials_4LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_4LoopEnd() {
  psychoJS.experiment.removeLoop(trials_4);

  return Scheduler.Event.NEXT;
}


var trials_5;
function trials_5LoopBegin(trials_5LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_5 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond3Trial2andBeyond,
    seed: undefined, name: 'trials_5'
  });
  psychoJS.experiment.addLoop(trials_5); // add the loop to the experiment
  currentLoop = trials_5;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_5 of trials_5) {
    const snapshot = trials_5.getSnapshot();
    trials_5LoopScheduler.add(importConditions(snapshot));
    trials_5LoopScheduler.add(cond3_trial2RoutineBegin(snapshot));
    trials_5LoopScheduler.add(cond3_trial2RoutineEachFrame(snapshot));
    trials_5LoopScheduler.add(cond3_trial2RoutineEnd(snapshot));
    trials_5LoopScheduler.add(endLoopIteration(trials_5LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_5LoopEnd() {
  psychoJS.experiment.removeLoop(trials_5);

  return Scheduler.Event.NEXT;
}


var trials_6;
function trials_6LoopBegin(trials_6LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_6 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond4Trial1,
    seed: undefined, name: 'trials_6'
  });
  psychoJS.experiment.addLoop(trials_6); // add the loop to the experiment
  currentLoop = trials_6;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_6 of trials_6) {
    const snapshot = trials_6.getSnapshot();
    trials_6LoopScheduler.add(importConditions(snapshot));
    trials_6LoopScheduler.add(cond4_trial1RoutineBegin(snapshot));
    trials_6LoopScheduler.add(cond4_trial1RoutineEachFrame(snapshot));
    trials_6LoopScheduler.add(cond4_trial1RoutineEnd(snapshot));
    trials_6LoopScheduler.add(endLoopIteration(trials_6LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_6LoopEnd() {
  psychoJS.experiment.removeLoop(trials_6);

  return Scheduler.Event.NEXT;
}


var trials_9;
function trials_9LoopBegin(trials_9LoopScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_9 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.SEQUENTIAL,
    extraInfo: expInfo, originPath: undefined,
    trialList: Cond4Trial2andBeyond,
    seed: undefined, name: 'trials_9'
  });
  psychoJS.experiment.addLoop(trials_9); // add the loop to the experiment
  currentLoop = trials_9;  // we're now the current loop

  // Schedule all the trials in the trialList:
  for (const thisTrial_9 of trials_9) {
    const snapshot = trials_9.getSnapshot();
    trials_9LoopScheduler.add(importConditions(snapshot));
    trials_9LoopScheduler.add(cond4_trial2RoutineBegin(snapshot));
    trials_9LoopScheduler.add(cond4_trial2RoutineEachFrame(snapshot));
    trials_9LoopScheduler.add(cond4_trial2RoutineEnd(snapshot));
    trials_9LoopScheduler.add(endLoopIteration(trials_9LoopScheduler, snapshot));
  }

  return Scheduler.Event.NEXT;
}


function trials_9LoopEnd() {
  psychoJS.experiment.removeLoop(trials_9);

  return Scheduler.Event.NEXT;
}


function conditions_3and4LoopEnd() {
  psychoJS.experiment.removeLoop(conditions_3and4);

  return Scheduler.Event.NEXT;
}


var gotValidClick;
var _confirm_net_13_allKeys;
var condition0_trial1Components;
function condition0_trial1RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'condition0_trial1'-------
    t = 0;
    condition0_trial1Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    cue_coin_13.setPos([cue_coin_posx, cue_coin_posy]);
    // setup some python lists for storing info about the mouse_14
    gotValidClick = false; // until a click is received
    confirm_net_13.keys = undefined;
    confirm_net_13.rt = undefined;
    _confirm_net_13_allKeys = [];
    net_shape_13.setPos([net_posx, net_posy]);
    // keep track of which components have finished
    condition0_trial1Components = [];
    condition0_trial1Components.push(cue_coin_13);
    condition0_trial1Components.push(mouse_14);
    condition0_trial1Components.push(confirm_net_13);
    condition0_trial1Components.push(fixation_13);
    condition0_trial1Components.push(net_shape_13);
    
    for (const thisComponent of condition0_trial1Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


var frameRemains;
function condition0_trial1RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'condition0_trial1'-------
    // get current time
    t = condition0_trial1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *cue_coin_13* updates
    if (t >= 0.5 && cue_coin_13.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_13.tStart = t;  // (not accounting for frame time here)
      cue_coin_13.frameNStart = frameN;  // exact frame index
      
      cue_coin_13.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_13.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_13.setAutoDraw(false);
    }
    
    // *confirm_net_13* updates
    if (t >= 1.0 && confirm_net_13.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_13.tStart = t;  // (not accounting for frame time here)
      confirm_net_13.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_13.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_13.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_13.clearEvents(); });
    }

    if (confirm_net_13.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_13.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_13_allKeys = _confirm_net_13_allKeys.concat(theseKeys);
      if (_confirm_net_13_allKeys.length > 0) {
        confirm_net_13.keys = _confirm_net_13_allKeys[_confirm_net_13_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_13.rt = _confirm_net_13_allKeys[_confirm_net_13_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *fixation_13* updates
    if (t >= 0.0 && fixation_13.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_13.tStart = t;  // (not accounting for frame time here)
      fixation_13.frameNStart = frameN;  // exact frame index
      
      fixation_13.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_13.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_13.setAutoDraw(false);
    }
    net_shape_13.pos = mouse_14.getPos();
    
    
    
    // *net_shape_13* updates
    if (t >= 1.0 && net_shape_13.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_13.tStart = t;  // (not accounting for frame time here)
      net_shape_13.frameNStart = frameN;  // exact frame index
      
      net_shape_13.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of condition0_trial1Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


var participant;
var condition;
var cueSD;
var walkSD;
var _mouseXYs;
var _mouseButtons;
function condition0_trial1RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'condition0_trial1'-------
    for (const thisComponent of condition0_trial1Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials.addData("participant", participant);
    trials.addData("condition", condition);
    trials.addData("cue SD", cueSD);
    trials.addData("walk SD", walkSD);
    trials.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_14.getPos();
    _mouseButtons = mouse_14.getPressed();
    psychoJS.experiment.addData('mouse_14.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_14.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_14.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_14.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_14.rightButton', _mouseButtons[2]);
    psychoJS.experiment.addData('confirm_net_13.keys', confirm_net_13.keys);
    if (typeof confirm_net_13.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_13.rt', confirm_net_13.rt);
        routineTimer.reset();
        }
    
    confirm_net_13.stop();
    trials.addData("feedback_net_posx_trial1",  mouse_14.getPos()[0]);
    
    // the Routine "condition0_trial1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_14_allKeys;
var condition0_trial2Components;
function condition0_trial2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'condition0_trial2'-------
    t = 0;
    condition0_trial2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    target_coin_3.setPos([target_coin_posx2, target_coin_posy2]);
    cue_coin_14.setPos([cue_coin_posx2, cue_coin_posy2]);
    net_shape_14.setPos([net_posx2, net_posy2]);
    // setup some python lists for storing info about the mouse_15
    mouse_15.clicked_name = [];
    gotValidClick = false; // until a click is received
    confirm_net_14.keys = undefined;
    confirm_net_14.rt = undefined;
    _confirm_net_14_allKeys = [];
    feedback_net_posx = mouse_15.getPos()[0];
    feedback_net_posy = mouse_15.getPos()[1];
    
    net_shape_feedback_7.setPos([feedback_net_posx, feedback_net_posy]);
    score_text_6.setText(gains);
    // keep track of which components have finished
    condition0_trial2Components = [];
    condition0_trial2Components.push(target_coin_3);
    condition0_trial2Components.push(cue_coin_14);
    condition0_trial2Components.push(net_shape_14);
    condition0_trial2Components.push(mouse_15);
    condition0_trial2Components.push(fixation_14);
    condition0_trial2Components.push(confirm_net_14);
    condition0_trial2Components.push(net_shape_feedback_7);
    condition0_trial2Components.push(score_text_6);
    
    for (const thisComponent of condition0_trial2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


var difference;
var rmdiff;
function condition0_trial2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'condition0_trial2'-------
    // get current time
    t = condition0_trial2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *target_coin_3* updates
    if (t >= 0.5 && target_coin_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      target_coin_3.tStart = t;  // (not accounting for frame time here)
      target_coin_3.frameNStart = frameN;  // exact frame index
      
      target_coin_3.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (target_coin_3.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      target_coin_3.setAutoDraw(false);
    }
    
    // *cue_coin_14* updates
    if (t >= 2.0 && cue_coin_14.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_14.tStart = t;  // (not accounting for frame time here)
      cue_coin_14.frameNStart = frameN;  // exact frame index
      
      cue_coin_14.setAutoDraw(true);
    }

    frameRemains = 2.0 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_14.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_14.setAutoDraw(false);
    }
    net_shape_14.pos = mouse_15.getPos();
    
    
    // *net_shape_14* updates
    if (t >= 2.5 && net_shape_14.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_14.tStart = t;  // (not accounting for frame time here)
      net_shape_14.frameNStart = frameN;  // exact frame index
      
      net_shape_14.setAutoDraw(true);
    }

    
    // *fixation_14* updates
    if (t >= 1.5 && fixation_14.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_14.tStart = t;  // (not accounting for frame time here)
      fixation_14.frameNStart = frameN;  // exact frame index
      
      fixation_14.setAutoDraw(true);
    }

    frameRemains = 1.5 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_14.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_14.setAutoDraw(false);
    }
    
    // *confirm_net_14* updates
    if (t >= 2.5 && confirm_net_14.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_14.tStart = t;  // (not accounting for frame time here)
      confirm_net_14.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_14.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_14.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_14.clearEvents(); });
    }

    if (confirm_net_14.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_14.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_14_allKeys = _confirm_net_14_allKeys.concat(theseKeys);
      if (_confirm_net_14_allKeys.length > 0) {
        confirm_net_14.keys = _confirm_net_14_allKeys[_confirm_net_14_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_14.rt = _confirm_net_14_allKeys[_confirm_net_14_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    //net_shape_feedback.pos = mouse_2.getPos();
    difference = (target_coin_posx2 - feedback_net_posx);
    
    rmdiff = Math.sqrt(Math.pow(difference, 2));
    if ((rmdiff < 0.05)) {
        feedback_color = green;
        border_color = green;
    
    } else {
        feedback_color = white;
        border_color = white;
    
    }
    
    
    // *net_shape_feedback_7* updates
    if (t >= 0.5 && net_shape_feedback_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_feedback_7.tStart = t;  // (not accounting for frame time here)
      net_shape_feedback_7.frameNStart = frameN;  // exact frame index
      
      net_shape_feedback_7.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (net_shape_feedback_7.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      net_shape_feedback_7.setAutoDraw(false);
    }
    
    if (net_shape_feedback_7.status === PsychoJS.Status.STARTED){ // only update if being drawn
      net_shape_feedback_7.setFillColor(new util.Color(feedback_color), false);
      net_shape_feedback_7.setOpacity(0.7, false);
      net_shape_feedback_7.setContrast(1.0, false);
      net_shape_feedback_7.setLineColor(new util.Color(border_color), false);
      net_shape_feedback_7.setLineWidth(1, false);
    }
    
    // *score_text_6* updates
    if (t >= 0.0 && score_text_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      score_text_6.tStart = t;  // (not accounting for frame time here)
      score_text_6.frameNStart = frameN;  // exact frame index
      
      score_text_6.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (score_text_6.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      score_text_6.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of condition0_trial2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function condition0_trial2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'condition0_trial2'-------
    for (const thisComponent of condition0_trial2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_0.addData("participant", participant);
    trials_0.addData("condition", condition);
    trials_0.addData("cue SD", cueSD);
    trials_0.addData("walk SD", walkSD);
    trials_0ab.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_15.getPos();
    _mouseButtons = mouse_15.getPressed();
    psychoJS.experiment.addData('mouse_15.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_15.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_15.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_15.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_15.rightButton', _mouseButtons[2]);
    if (mouse_15.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_15.clicked_name', mouse_15.clicked_name[0]);}
    psychoJS.experiment.addData('confirm_net_14.keys', confirm_net_14.keys);
    if (typeof confirm_net_14.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_14.rt', confirm_net_14.rt);
        routineTimer.reset();
        }
    
    confirm_net_14.stop();
    net_shape_feedback_7.pos = mouse_15.getPos();
    trials_0.addData("rmdiff", rmdiff);
    trials_0.addData("feedback_net_posx_trial2onwards",  mouse_15.getPos()[0]);
    
    
    if ((feedback_color == green)) {
        gains = gains+(100);
    
    } else {
        gains=gains;
    
    }
    score_text_6.setAutoDraw(true);
    // the Routine "condition0_trial2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _key_resp_allKeys;
var condition_order1Components;
function condition_order1RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'condition_order1'-------
    t = 0;
    condition_order1Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    text_6.setText(condition1);
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    if (((Number.parseInt(expInfo["participant"]) % 2) === 0)) {
        condition1 = "Press space to begin the first condition";
        condition2 = "Press space to begin the second condition";
    } else {
        condition1 = "Press space to begin the second condition";
        condition2 = "Press space to begin the first condition";
    }
    
    // keep track of which components have finished
    condition_order1Components = [];
    condition_order1Components.push(text_6);
    condition_order1Components.push(key_resp);
    
    for (const thisComponent of condition_order1Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function condition_order1RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'condition_order1'-------
    // get current time
    t = condition_order1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_6* updates
    if (t >= 0.0 && text_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_6.tStart = t;  // (not accounting for frame time here)
      text_6.frameNStart = frameN;  // exact frame index
      
      text_6.setAutoDraw(true);
    }

    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of condition_order1Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function condition_order1RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'condition_order1'-------
    for (const thisComponent of condition_order1Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "condition_order1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_allKeys;
var cond1_trialComponents;
function cond1_trialRoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond1_trial'-------
    t = 0;
    cond1_trialClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    cue_coin.setPos([cue_coin_posx, cue_coin_posy]);
    // setup some python lists for storing info about the mouse
    gotValidClick = false; // until a click is received
    confirm_net.keys = undefined;
    confirm_net.rt = undefined;
    _confirm_net_allKeys = [];
    
    
    net_shape.setPos([net_posx, net_posy]);
    // keep track of which components have finished
    cond1_trialComponents = [];
    cond1_trialComponents.push(cue_coin);
    cond1_trialComponents.push(mouse);
    cond1_trialComponents.push(confirm_net);
    cond1_trialComponents.push(fixation);
    cond1_trialComponents.push(net_shape);
    
    for (const thisComponent of cond1_trialComponents)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond1_trialRoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond1_trial'-------
    // get current time
    t = cond1_trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *cue_coin* updates
    if (t >= 0.5 && cue_coin.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin.tStart = t;  // (not accounting for frame time here)
      cue_coin.frameNStart = frameN;  // exact frame index
      
      cue_coin.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin.setAutoDraw(false);
    }
    
    // *confirm_net* updates
    if (t >= 1.0 && confirm_net.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net.tStart = t;  // (not accounting for frame time here)
      confirm_net.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net.clearEvents(); });
    }

    if (confirm_net.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_allKeys = _confirm_net_allKeys.concat(theseKeys);
      if (_confirm_net_allKeys.length > 0) {
        confirm_net.keys = _confirm_net_allKeys[_confirm_net_allKeys.length - 1].name;  // just the last key pressed
        confirm_net.rt = _confirm_net_allKeys[_confirm_net_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *fixation* updates
    if (t >= 0.0 && fixation.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation.tStart = t;  // (not accounting for frame time here)
      fixation.frameNStart = frameN;  // exact frame index
      
      fixation.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation.setAutoDraw(false);
    }
    net_shape.pos = mouse.getPos();
    
    
    
    // *net_shape* updates
    if (t >= 1.0 && net_shape.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape.tStart = t;  // (not accounting for frame time here)
      net_shape.frameNStart = frameN;  // exact frame index
      
      net_shape.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond1_trialComponents)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond1_trialRoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond1_trial'-------
    for (const thisComponent of cond1_trialComponents) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_1.addData("participant", participant);
    trials_1.addData("condition", condition);
    trials_1.addData("cue SD", cueSD);
    trials_1.addData("walk SD", walkSD);
    trials_1.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse.getPos();
    _mouseButtons = mouse.getPressed();
    psychoJS.experiment.addData('mouse.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse.rightButton', _mouseButtons[2]);
    psychoJS.experiment.addData('confirm_net.keys', confirm_net.keys);
    if (typeof confirm_net.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net.rt', confirm_net.rt);
        routineTimer.reset();
        }
    
    confirm_net.stop();
    trials_1.addData("feedback_net_posx_trial1",  mouse.getPos()[0]);
    // the Routine "cond1_trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_2_allKeys;
var cond1_trial_2Components;
function cond1_trial_2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond1_trial_2'-------
    t = 0;
    cond1_trial_2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    target_coin_2.setPos([target_coin_posx2, target_coin_posy2]);
    cue_coin_2.setPos([cue_coin_posx2, cue_coin_posy2]);
    net_shape_2.setPos([net_posx2, net_posy2]);
    // setup some python lists for storing info about the mouse_2
    mouse_2.clicked_name = [];
    gotValidClick = false; // until a click is received
    confirm_net_2.keys = undefined;
    confirm_net_2.rt = undefined;
    _confirm_net_2_allKeys = [];
    feedback_net_posx = mouse_2.getPos()[0]
    feedback_net_posy = mouse_2.getPos()[1]
    
    score_text_6.setAutoDraw(false);
    net_shape_feedback.setPos([feedback_net_posx, feedback_net_posy]);
    score_text_2.setText(gains);
    // keep track of which components have finished
    cond1_trial_2Components = [];
    cond1_trial_2Components.push(target_coin_2);
    cond1_trial_2Components.push(cue_coin_2);
    cond1_trial_2Components.push(net_shape_2);
    cond1_trial_2Components.push(mouse_2);
    cond1_trial_2Components.push(fixation_2);
    cond1_trial_2Components.push(confirm_net_2);
    cond1_trial_2Components.push(net_shape_feedback);
    cond1_trial_2Components.push(score_text_2);
    
    for (const thisComponent of cond1_trial_2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond1_trial_2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond1_trial_2'-------
    // get current time
    t = cond1_trial_2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *target_coin_2* updates
    if (t >= 0.5 && target_coin_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      target_coin_2.tStart = t;  // (not accounting for frame time here)
      target_coin_2.frameNStart = frameN;  // exact frame index
      
      target_coin_2.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (target_coin_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      target_coin_2.setAutoDraw(false);
    }
    
    // *cue_coin_2* updates
    if (t >= 2.0 && cue_coin_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_2.tStart = t;  // (not accounting for frame time here)
      cue_coin_2.frameNStart = frameN;  // exact frame index
      
      cue_coin_2.setAutoDraw(true);
    }

    frameRemains = 2.0 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_2.setAutoDraw(false);
    }
    net_shape_2.pos = mouse_2.getPos();
    
    
    // *net_shape_2* updates
    if (t >= 2.5 && net_shape_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_2.tStart = t;  // (not accounting for frame time here)
      net_shape_2.frameNStart = frameN;  // exact frame index
      
      net_shape_2.setAutoDraw(true);
    }

    
    // *fixation_2* updates
    if (t >= 1.5 && fixation_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_2.tStart = t;  // (not accounting for frame time here)
      fixation_2.frameNStart = frameN;  // exact frame index
      
      fixation_2.setAutoDraw(true);
    }

    frameRemains = 1.5 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_2.setAutoDraw(false);
    }
    
    // *confirm_net_2* updates
    if (t >= 2.5 && confirm_net_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_2.tStart = t;  // (not accounting for frame time here)
      confirm_net_2.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_2.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_2.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_2.clearEvents(); });
    }

    if (confirm_net_2.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_2.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_2_allKeys = _confirm_net_2_allKeys.concat(theseKeys);
      if (_confirm_net_2_allKeys.length > 0) {
        confirm_net_2.keys = _confirm_net_2_allKeys[_confirm_net_2_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_2.rt = _confirm_net_2_allKeys[_confirm_net_2_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    //net_shape_feedback.pos = mouse_2.getPos();
    difference = (target_coin_posx2 - feedback_net_posx);
    
    rmdiff = Math.sqrt(Math.pow(difference, 2));
    if ((rmdiff < 0.05)) {
        feedback_color = green;
        border_color = green;
    
    } else {
        feedback_color = white;
        border_color = white;
    
    }
    
    
    // *net_shape_feedback* updates
    if (t >= 0.5 && net_shape_feedback.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_feedback.tStart = t;  // (not accounting for frame time here)
      net_shape_feedback.frameNStart = frameN;  // exact frame index
      
      net_shape_feedback.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (net_shape_feedback.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      net_shape_feedback.setAutoDraw(false);
    }
    
    if (net_shape_feedback.status === PsychoJS.Status.STARTED){ // only update if being drawn
      net_shape_feedback.setFillColor(new util.Color(feedback_color), false);
      net_shape_feedback.setOpacity(0.7, false);
      net_shape_feedback.setContrast(1.0, false);
      net_shape_feedback.setLineColor(new util.Color(border_color), false);
      net_shape_feedback.setLineWidth(1, false);
    }
    
    // *score_text_2* updates
    if (t >= 0.0 && score_text_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      score_text_2.tStart = t;  // (not accounting for frame time here)
      score_text_2.frameNStart = frameN;  // exact frame index
      
      score_text_2.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (score_text_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      score_text_2.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond1_trial_2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond1_trial_2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond1_trial_2'-------
    for (const thisComponent of cond1_trial_2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_2.addData("participant", participant);
    trials_2.addData("condition", condition);
    trials_2.addData("cue SD", cueSD);
    trials_2.addData("walk SD", walkSD);
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_2.getPos();
    _mouseButtons = mouse_2.getPressed();
    psychoJS.experiment.addData('mouse_2.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_2.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_2.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_2.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_2.rightButton', _mouseButtons[2]);
    if (mouse_2.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_2.clicked_name', mouse_2.clicked_name[0]);}
    psychoJS.experiment.addData('confirm_net_2.keys', confirm_net_2.keys);
    if (typeof confirm_net_2.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_2.rt', confirm_net_2.rt);
        routineTimer.reset();
        }
    
    confirm_net_2.stop();
    //net_shape_feedback.setAutoDraw(false);
    net_shape_feedback.pos = mouse_2.getPos()
    trials_2.addData("rmdiff", rmdiff);
    trials_2.addData("feedback_net_posx_trial2onwards",  mouse_2.getPos()[0]);
    
    if ((feedback_color == green)) {
        gains = gains+(100);
    
    } else {
        gains=gains;
    
    }
    score_text_2.setAutoDraw(true);
    // the Routine "cond1_trial_2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _break_resp_allKeys;
var BreakScreenComponents;
function BreakScreenRoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'BreakScreen'-------
    t = 0;
    BreakScreenClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    break_resp.keys = undefined;
    break_resp.rt = undefined;
    _break_resp_allKeys = [];
    // keep track of which components have finished
    BreakScreenComponents = [];
    BreakScreenComponents.push(break_text);
    BreakScreenComponents.push(break_resp);
    
    for (const thisComponent of BreakScreenComponents)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function BreakScreenRoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'BreakScreen'-------
    // get current time
    t = BreakScreenClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *break_text* updates
    if (t >= 0.0 && break_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      break_text.tStart = t;  // (not accounting for frame time here)
      break_text.frameNStart = frameN;  // exact frame index
      
      break_text.setAutoDraw(true);
    }

    
    // *break_resp* updates
    if (t >= 0.0 && break_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      break_resp.tStart = t;  // (not accounting for frame time here)
      break_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { break_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { break_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { break_resp.clearEvents(); });
    }

    if (break_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = break_resp.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _break_resp_allKeys = _break_resp_allKeys.concat(theseKeys);
      if (_break_resp_allKeys.length > 0) {
        break_resp.keys = _break_resp_allKeys[_break_resp_allKeys.length - 1].name;  // just the last key pressed
        break_resp.rt = _break_resp_allKeys[_break_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of BreakScreenComponents)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function BreakScreenRoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'BreakScreen'-------
    for (const thisComponent of BreakScreenComponents) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('break_resp.keys', break_resp.keys);
    if (typeof break_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('break_resp.rt', break_resp.rt);
        routineTimer.reset();
        }
    
    break_resp.stop();
    // the Routine "BreakScreen" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_3_allKeys;
var cond2_trial1Components;
function cond2_trial1RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond2_trial1'-------
    t = 0;
    cond2_trial1Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    cue_coin_3.setPos([cue_coin_posx, cue_coin_posy]);
    // setup some python lists for storing info about the mouse_4
    gotValidClick = false; // until a click is received
    confirm_net_3.keys = undefined;
    confirm_net_3.rt = undefined;
    _confirm_net_3_allKeys = [];
    net_shape_3.setPos([net_posx, net_posy]);
    // keep track of which components have finished
    cond2_trial1Components = [];
    cond2_trial1Components.push(cue_coin_3);
    cond2_trial1Components.push(mouse_4);
    cond2_trial1Components.push(confirm_net_3);
    cond2_trial1Components.push(fixation_3);
    cond2_trial1Components.push(net_shape_3);
    
    for (const thisComponent of cond2_trial1Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond2_trial1RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond2_trial1'-------
    // get current time
    t = cond2_trial1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *cue_coin_3* updates
    if (t >= 0.5 && cue_coin_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_3.tStart = t;  // (not accounting for frame time here)
      cue_coin_3.frameNStart = frameN;  // exact frame index
      
      cue_coin_3.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_3.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_3.setAutoDraw(false);
    }
    
    // *confirm_net_3* updates
    if (t >= 1.0 && confirm_net_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_3.tStart = t;  // (not accounting for frame time here)
      confirm_net_3.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_3.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_3.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_3.clearEvents(); });
    }

    if (confirm_net_3.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_3.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_3_allKeys = _confirm_net_3_allKeys.concat(theseKeys);
      if (_confirm_net_3_allKeys.length > 0) {
        confirm_net_3.keys = _confirm_net_3_allKeys[_confirm_net_3_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_3.rt = _confirm_net_3_allKeys[_confirm_net_3_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *fixation_3* updates
    if (t >= 0.0 && fixation_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_3.tStart = t;  // (not accounting for frame time here)
      fixation_3.frameNStart = frameN;  // exact frame index
      
      fixation_3.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_3.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_3.setAutoDraw(false);
    }
    net_shape_3.pos = mouse_4.getPos();
    
    
    // *net_shape_3* updates
    if (t >= 1.0 && net_shape_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_3.tStart = t;  // (not accounting for frame time here)
      net_shape_3.frameNStart = frameN;  // exact frame index
      
      net_shape_3.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond2_trial1Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond2_trial1RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond2_trial1'-------
    for (const thisComponent of cond2_trial1Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_7.addData("participant", participant);
    trials_7.addData("condition", condition);
    trials_7.addData("cue SD", cueSD);
    trials_7.addData("walk SD", walkSD);
    trials_7.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_4.getPos();
    _mouseButtons = mouse_4.getPressed();
    psychoJS.experiment.addData('mouse_4.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_4.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_4.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_4.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_4.rightButton', _mouseButtons[2]);
    psychoJS.experiment.addData('confirm_net_3.keys', confirm_net_3.keys);
    if (typeof confirm_net_3.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_3.rt', confirm_net_3.rt);
        routineTimer.reset();
        }
    
    confirm_net_3.stop();
    trials_7.addData("feedback_net_posx_trial1", mouse_4.getPos()[0]);
    
    // the Routine "cond2_trial1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_4_allKeys;
var cond2_trial_2Components;
function cond2_trial_2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond2_trial_2'-------
    t = 0;
    cond2_trial_2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    target_coin_4.setPos([target_coin_posx2, target_coin_posy2]);
    cue_coin_4.setPos([cue_coin_posx2, cue_coin_posy2]);
    net_shape_4.setPos([net_posx2, net_posy2]);
    // setup some python lists for storing info about the mouse_5
    mouse_5.clicked_name = [];
    gotValidClick = false; // until a click is received
    confirm_net_4.keys = undefined;
    confirm_net_4.rt = undefined;
    _confirm_net_4_allKeys = [];
    feedback_net_posx = mouse_5.getPos()[0]
    feedback_net_posy = mouse_5.getPos()[1]
    
    score_text_2.setAutoDraw(false);
    net_shape_feedback_2.setPos([feedback_net_posx, feedback_net_posy]);
    score_text_3.setText(gains);
    // keep track of which components have finished
    cond2_trial_2Components = [];
    cond2_trial_2Components.push(target_coin_4);
    cond2_trial_2Components.push(cue_coin_4);
    cond2_trial_2Components.push(net_shape_4);
    cond2_trial_2Components.push(mouse_5);
    cond2_trial_2Components.push(fixation_4);
    cond2_trial_2Components.push(confirm_net_4);
    cond2_trial_2Components.push(net_shape_feedback_2);
    cond2_trial_2Components.push(score_text_3);
    
    for (const thisComponent of cond2_trial_2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond2_trial_2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond2_trial_2'-------
    // get current time
    t = cond2_trial_2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *target_coin_4* updates
    if (t >= 0.5 && target_coin_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      target_coin_4.tStart = t;  // (not accounting for frame time here)
      target_coin_4.frameNStart = frameN;  // exact frame index
      
      target_coin_4.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (target_coin_4.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      target_coin_4.setAutoDraw(false);
    }
    
    // *cue_coin_4* updates
    if (t >= 2.0 && cue_coin_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_4.tStart = t;  // (not accounting for frame time here)
      cue_coin_4.frameNStart = frameN;  // exact frame index
      
      cue_coin_4.setAutoDraw(true);
    }

    frameRemains = 2.0 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_4.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_4.setAutoDraw(false);
    }
    net_shape_4.pos = mouse_5.getPos();
    
    
    // *net_shape_4* updates
    if (t >= 2.5 && net_shape_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_4.tStart = t;  // (not accounting for frame time here)
      net_shape_4.frameNStart = frameN;  // exact frame index
      
      net_shape_4.setAutoDraw(true);
    }

    
    // *fixation_4* updates
    if (t >= 1.5 && fixation_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_4.tStart = t;  // (not accounting for frame time here)
      fixation_4.frameNStart = frameN;  // exact frame index
      
      fixation_4.setAutoDraw(true);
    }

    frameRemains = 1.5 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_4.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_4.setAutoDraw(false);
    }
    
    // *confirm_net_4* updates
    if (t >= 2.5 && confirm_net_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_4.tStart = t;  // (not accounting for frame time here)
      confirm_net_4.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_4.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_4.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_4.clearEvents(); });
    }

    if (confirm_net_4.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_4.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_4_allKeys = _confirm_net_4_allKeys.concat(theseKeys);
      if (_confirm_net_4_allKeys.length > 0) {
        confirm_net_4.keys = _confirm_net_4_allKeys[_confirm_net_4_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_4.rt = _confirm_net_4_allKeys[_confirm_net_4_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    //net_shape_feedback.pos = mouse_2.getPos();
    difference = (target_coin_posx2 - feedback_net_posx);
    
    rmdiff = Math.sqrt(Math.pow(difference, 2));
    if ((rmdiff < 0.05)) {
        feedback_color = green;
        border_color = green;
    
    } else {
        feedback_color = white;
        border_color = white;
    
    }
    
    
    
    // *net_shape_feedback_2* updates
    if (t >= 0.5 && net_shape_feedback_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_feedback_2.tStart = t;  // (not accounting for frame time here)
      net_shape_feedback_2.frameNStart = frameN;  // exact frame index
      
      net_shape_feedback_2.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (net_shape_feedback_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      net_shape_feedback_2.setAutoDraw(false);
    }
    
    if (net_shape_feedback_2.status === PsychoJS.Status.STARTED){ // only update if being drawn
      net_shape_feedback_2.setFillColor(new util.Color(feedback_color), false);
      net_shape_feedback_2.setLineColor(new util.Color(border_color), false);
    }
    
    // *score_text_3* updates
    if (t >= 0.0 && score_text_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      score_text_3.tStart = t;  // (not accounting for frame time here)
      score_text_3.frameNStart = frameN;  // exact frame index
      
      score_text_3.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (score_text_3.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      score_text_3.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond2_trial_2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond2_trial_2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond2_trial_2'-------
    for (const thisComponent of cond2_trial_2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_3.addData("participant", participant);
    trials_3.addData("condition", condition);
    trials_3.addData("cue SD", cueSD);
    trials_3.addData("walk SD", walkSD);
    conditions_1and2.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_5.getPos();
    _mouseButtons = mouse_5.getPressed();
    psychoJS.experiment.addData('mouse_5.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_5.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_5.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_5.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_5.rightButton', _mouseButtons[2]);
    if (mouse_5.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_5.clicked_name', mouse_5.clicked_name[0]);}
    psychoJS.experiment.addData('confirm_net_4.keys', confirm_net_4.keys);
    if (typeof confirm_net_4.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_4.rt', confirm_net_4.rt);
        routineTimer.reset();
        }
    
    confirm_net_4.stop();
    //net_shape_feedback.setAutoDraw(false);
    net_shape_feedback.pos = mouse_5.getPos()
    trials_3.addData("rmdiff", rmdiff);
    trials_3.addData("feedback_net_posx_trial2onwards",  mouse_5.getPos()[0]);
    
    if ((feedback_color == green)) {
        gains = gains+(100);
    
    } else {
        gains=gains;
    
    }
    score_text_3.setAutoDraw(true);
    // the Routine "cond2_trial_2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _key_resp_2_allKeys;
var condition_order2Components;
function condition_order2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'condition_order2'-------
    t = 0;
    condition_order2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    text_7.setText(condition2);
    key_resp_2.keys = undefined;
    key_resp_2.rt = undefined;
    _key_resp_2_allKeys = [];
    condition1 = "Press space to begin the second condition";
    condition2 = "Press space to begin the third condition";
    
    // keep track of which components have finished
    condition_order2Components = [];
    condition_order2Components.push(text_7);
    condition_order2Components.push(key_resp_2);
    
    for (const thisComponent of condition_order2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function condition_order2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'condition_order2'-------
    // get current time
    t = condition_order2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_7* updates
    if (t >= 0.0 && text_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_7.tStart = t;  // (not accounting for frame time here)
      text_7.frameNStart = frameN;  // exact frame index
      
      text_7.setAutoDraw(true);
    }

    
    // *key_resp_2* updates
    if (t >= 0.0 && key_resp_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_2.tStart = t;  // (not accounting for frame time here)
      key_resp_2.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_2.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_2.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_2.clearEvents(); });
    }

    if (key_resp_2.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_2.getKeys({keyList: ['space'], waitRelease: false});
      _key_resp_2_allKeys = _key_resp_2_allKeys.concat(theseKeys);
      if (_key_resp_2_allKeys.length > 0) {
        key_resp_2.keys = _key_resp_2_allKeys[_key_resp_2_allKeys.length - 1].name;  // just the last key pressed
        key_resp_2.rt = _key_resp_2_allKeys[_key_resp_2_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of condition_order2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function condition_order2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'condition_order2'-------
    for (const thisComponent of condition_order2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('key_resp_2.keys', key_resp_2.keys);
    if (typeof key_resp_2.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_2.rt', key_resp_2.rt);
        routineTimer.reset();
        }
    
    key_resp_2.stop();
    // the Routine "condition_order2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_6_allKeys;
var cond3_trial1Components;
function cond3_trial1RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond3_trial1'-------
    t = 0;
    cond3_trial1Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    cue_coin_5.setPos([cue_coin_posx, cue_coin_posy]);
    // setup some python lists for storing info about the mouse_6
    gotValidClick = false; // until a click is received
    confirm_net_6.keys = undefined;
    confirm_net_6.rt = undefined;
    _confirm_net_6_allKeys = [];
    net_shape_5.setPos([net_posx, net_posy]);
    // keep track of which components have finished
    cond3_trial1Components = [];
    cond3_trial1Components.push(cue_coin_5);
    cond3_trial1Components.push(mouse_6);
    cond3_trial1Components.push(confirm_net_6);
    cond3_trial1Components.push(fixation_5);
    cond3_trial1Components.push(net_shape_5);
    
    for (const thisComponent of cond3_trial1Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond3_trial1RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond3_trial1'-------
    // get current time
    t = cond3_trial1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *cue_coin_5* updates
    if (t >= 0.5 && cue_coin_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_5.tStart = t;  // (not accounting for frame time here)
      cue_coin_5.frameNStart = frameN;  // exact frame index
      
      cue_coin_5.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_5.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_5.setAutoDraw(false);
    }
    
    // *confirm_net_6* updates
    if (t >= 1.0 && confirm_net_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_6.tStart = t;  // (not accounting for frame time here)
      confirm_net_6.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_6.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_6.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_6.clearEvents(); });
    }

    if (confirm_net_6.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_6.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_6_allKeys = _confirm_net_6_allKeys.concat(theseKeys);
      if (_confirm_net_6_allKeys.length > 0) {
        confirm_net_6.keys = _confirm_net_6_allKeys[_confirm_net_6_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_6.rt = _confirm_net_6_allKeys[_confirm_net_6_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *fixation_5* updates
    if (t >= 0.0 && fixation_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_5.tStart = t;  // (not accounting for frame time here)
      fixation_5.frameNStart = frameN;  // exact frame index
      
      fixation_5.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_5.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_5.setAutoDraw(false);
    }
    net_shape_5.pos = mouse_6.getPos();
    
    
    // *net_shape_5* updates
    if (t >= 1.0 && net_shape_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_5.tStart = t;  // (not accounting for frame time here)
      net_shape_5.frameNStart = frameN;  // exact frame index
      
      net_shape_5.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond3_trial1Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond3_trial1RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond3_trial1'-------
    for (const thisComponent of cond3_trial1Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_4.addData("participant", participant);
    trials_4.addData("condition", condition);
    trials_4.addData("cue SD", cueSD);
    trials_4.addData("walk SD", walkSD);
    trials_4.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_6.getPos();
    _mouseButtons = mouse_6.getPressed();
    psychoJS.experiment.addData('mouse_6.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_6.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_6.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_6.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_6.rightButton', _mouseButtons[2]);
    psychoJS.experiment.addData('confirm_net_6.keys', confirm_net_6.keys);
    if (typeof confirm_net_6.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_6.rt', confirm_net_6.rt);
        routineTimer.reset();
        }
    
    confirm_net_6.stop();
    trials_4.addData("feedback_net_posx_trial1", mouse_6.getPos()[0]);
    
    // the Routine "cond3_trial1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_5_allKeys;
var cond3_trial2Components;
function cond3_trial2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond3_trial2'-------
    t = 0;
    cond3_trial2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    target_coin_6.setPos([target_coin_posx2, target_coin_posy2]);
    cue_coin_6.setPos([cue_coin_posx2, cue_coin_posy2]);
    net_shape_6.setPos([net_posx2, net_posy2]);
    // setup some python lists for storing info about the mouse_7
    mouse_7.clicked_name = [];
    gotValidClick = false; // until a click is received
    confirm_net_5.keys = undefined;
    confirm_net_5.rt = undefined;
    _confirm_net_5_allKeys = [];
    feedback_net_posx = mouse_7.getPos()[0];
    feedback_net_posy = mouse_7.getPos()[1];
    
    score_text_3.setAutoDraw(false);
    net_shape_feedback_3.setPos([feedback_net_posx, feedback_net_posy]);
    score_text_4.setText(gains);
    // keep track of which components have finished
    cond3_trial2Components = [];
    cond3_trial2Components.push(target_coin_6);
    cond3_trial2Components.push(cue_coin_6);
    cond3_trial2Components.push(net_shape_6);
    cond3_trial2Components.push(mouse_7);
    cond3_trial2Components.push(fixation_6);
    cond3_trial2Components.push(confirm_net_5);
    cond3_trial2Components.push(net_shape_feedback_3);
    cond3_trial2Components.push(score_text_4);
    
    for (const thisComponent of cond3_trial2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond3_trial2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond3_trial2'-------
    // get current time
    t = cond3_trial2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *target_coin_6* updates
    if (t >= 0.5 && target_coin_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      target_coin_6.tStart = t;  // (not accounting for frame time here)
      target_coin_6.frameNStart = frameN;  // exact frame index
      
      target_coin_6.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (target_coin_6.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      target_coin_6.setAutoDraw(false);
    }
    
    // *cue_coin_6* updates
    if (t >= 2.0 && cue_coin_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_6.tStart = t;  // (not accounting for frame time here)
      cue_coin_6.frameNStart = frameN;  // exact frame index
      
      cue_coin_6.setAutoDraw(true);
    }

    frameRemains = 2.0 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_6.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_6.setAutoDraw(false);
    }
    net_shape_6.pos = mouse_7.getPos();
    
    
    // *net_shape_6* updates
    if (t >= 2.5 && net_shape_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_6.tStart = t;  // (not accounting for frame time here)
      net_shape_6.frameNStart = frameN;  // exact frame index
      
      net_shape_6.setAutoDraw(true);
    }

    
    // *fixation_6* updates
    if (t >= 1.5 && fixation_6.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_6.tStart = t;  // (not accounting for frame time here)
      fixation_6.frameNStart = frameN;  // exact frame index
      
      fixation_6.setAutoDraw(true);
    }

    frameRemains = 1.5 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_6.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_6.setAutoDraw(false);
    }
    
    // *confirm_net_5* updates
    if (t >= 2.5 && confirm_net_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_5.tStart = t;  // (not accounting for frame time here)
      confirm_net_5.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_5.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_5.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_5.clearEvents(); });
    }

    if (confirm_net_5.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_5.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_5_allKeys = _confirm_net_5_allKeys.concat(theseKeys);
      if (_confirm_net_5_allKeys.length > 0) {
        confirm_net_5.keys = _confirm_net_5_allKeys[_confirm_net_5_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_5.rt = _confirm_net_5_allKeys[_confirm_net_5_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    //net_shape_feedback_3.pos = mouse_7.getPos();
    difference = (target_coin_posx2 - feedback_net_posx);
    
    rmdiff = Math.sqrt(Math.pow(difference, 2));
    if ((rmdiff < 0.05)) {
        feedback_color = green;
        border_color = green;
    
    } else {
        feedback_color = white;
        border_color = white;
    
    }
    
    
    
    
    // *net_shape_feedback_3* updates
    if (t >= 0.5 && net_shape_feedback_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_feedback_3.tStart = t;  // (not accounting for frame time here)
      net_shape_feedback_3.frameNStart = frameN;  // exact frame index
      
      net_shape_feedback_3.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (net_shape_feedback_3.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      net_shape_feedback_3.setAutoDraw(false);
    }
    
    if (net_shape_feedback_3.status === PsychoJS.Status.STARTED){ // only update if being drawn
      net_shape_feedback_3.setFillColor(new util.Color(feedback_color), false);
      net_shape_feedback_3.setLineColor(new util.Color(border_color), false);
    }
    
    // *score_text_4* updates
    if (t >= 0.0 && score_text_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      score_text_4.tStart = t;  // (not accounting for frame time here)
      score_text_4.frameNStart = frameN;  // exact frame index
      
      score_text_4.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (score_text_4.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      score_text_4.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond3_trial2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond3_trial2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond3_trial2'-------
    for (const thisComponent of cond3_trial2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_5.addData("participant", participant);
    trials_5.addData("condition", condition);
    trials_5.addData("cue SD", cueSD);
    trials_5.addData("walk SD", walkSD);
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_7.getPos();
    _mouseButtons = mouse_7.getPressed();
    psychoJS.experiment.addData('mouse_7.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_7.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_7.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_7.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_7.rightButton', _mouseButtons[2]);
    if (mouse_7.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_7.clicked_name', mouse_7.clicked_name[0]);}
    psychoJS.experiment.addData('confirm_net_5.keys', confirm_net_5.keys);
    if (typeof confirm_net_5.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_5.rt', confirm_net_5.rt);
        routineTimer.reset();
        }
    
    confirm_net_5.stop();
    //net_shape_feedback.setAutoDraw(false);
    net_shape_feedback.pos = mouse_7.getPos()
    trials_5.addData("rmdiff", rmdiff);
    trials_5.addData("feedback_net_posx_trial2onwards",  mouse_7.getPos()[0]);
    
    if ((feedback_color == green)) {
        gains = gains+(100);
    
    } else {
        gains=gains;
    
    }
    score_text_4.setAutoDraw(true);
    // the Routine "cond3_trial2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_7_allKeys;
var cond4_trial1Components;
function cond4_trial1RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond4_trial1'-------
    t = 0;
    cond4_trial1Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    cue_coin_7.setPos([cue_coin_posx, cue_coin_posy]);
    // setup some python lists for storing info about the mouse_8
    gotValidClick = false; // until a click is received
    confirm_net_7.keys = undefined;
    confirm_net_7.rt = undefined;
    _confirm_net_7_allKeys = [];
    net_shape_7.setPos([net_posx, net_posy]);
    // keep track of which components have finished
    cond4_trial1Components = [];
    cond4_trial1Components.push(cue_coin_7);
    cond4_trial1Components.push(mouse_8);
    cond4_trial1Components.push(confirm_net_7);
    cond4_trial1Components.push(fixation_7);
    cond4_trial1Components.push(net_shape_7);
    
    for (const thisComponent of cond4_trial1Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond4_trial1RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond4_trial1'-------
    // get current time
    t = cond4_trial1Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *cue_coin_7* updates
    if (t >= 0.5 && cue_coin_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_7.tStart = t;  // (not accounting for frame time here)
      cue_coin_7.frameNStart = frameN;  // exact frame index
      
      cue_coin_7.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_7.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_7.setAutoDraw(false);
    }
    
    // *confirm_net_7* updates
    if (t >= 1.0 && confirm_net_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_7.tStart = t;  // (not accounting for frame time here)
      confirm_net_7.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_7.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_7.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_7.clearEvents(); });
    }

    if (confirm_net_7.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_7.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_7_allKeys = _confirm_net_7_allKeys.concat(theseKeys);
      if (_confirm_net_7_allKeys.length > 0) {
        confirm_net_7.keys = _confirm_net_7_allKeys[_confirm_net_7_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_7.rt = _confirm_net_7_allKeys[_confirm_net_7_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    
    // *fixation_7* updates
    if (t >= 0.0 && fixation_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_7.tStart = t;  // (not accounting for frame time here)
      fixation_7.frameNStart = frameN;  // exact frame index
      
      fixation_7.setAutoDraw(true);
    }

    frameRemains = 0.0 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_7.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_7.setAutoDraw(false);
    }
    net_shape_7.pos = mouse_8.getPos();
    
    
    // *net_shape_7* updates
    if (t >= 1.0 && net_shape_7.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_7.tStart = t;  // (not accounting for frame time here)
      net_shape_7.frameNStart = frameN;  // exact frame index
      
      net_shape_7.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond4_trial1Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond4_trial1RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond4_trial1'-------
    for (const thisComponent of cond4_trial1Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_6.addData("participant", participant);
    trials_6.addData("condition", condition);
    trials_6.addData("cue SD", cueSD);
    trials_6.addData("walk SD", walkSD);
    trials_6.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_8.getPos();
    _mouseButtons = mouse_8.getPressed();
    psychoJS.experiment.addData('mouse_8.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_8.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_8.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_8.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_8.rightButton', _mouseButtons[2]);
    psychoJS.experiment.addData('confirm_net_7.keys', confirm_net_7.keys);
    if (typeof confirm_net_7.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_7.rt', confirm_net_7.rt);
        routineTimer.reset();
        }
    
    confirm_net_7.stop();
    trials_6.addData("feedback_net_posx_trial1", mouse_8.getPos()[0]);
    
    // the Routine "cond4_trial1" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _confirm_net_8_allKeys;
var cond4_trial2Components;
function cond4_trial2RoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'cond4_trial2'-------
    t = 0;
    cond4_trial2Clock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    target_coin_8.setPos([target_coin_posx2, target_coin_posy2]);
    cue_coin_8.setPos([cue_coin_posx2, cue_coin_posy2]);
    net_shape_8.setPos([net_posx2, net_posy2]);
    // setup some python lists for storing info about the mouse_9
    mouse_9.clicked_name = [];
    gotValidClick = false; // until a click is received
    confirm_net_8.keys = undefined;
    confirm_net_8.rt = undefined;
    _confirm_net_8_allKeys = [];
    feedback_net_posx = mouse_9.getPos()[0];
    feedback_net_posy = mouse_9.getPos()[1];
    
    score_text_4.setAutoDraw(false);
    
    net_shape_feedback_4.setPos([feedback_net_posx, feedback_net_posy]);
    score_text_5.setText(gains);
    // keep track of which components have finished
    cond4_trial2Components = [];
    cond4_trial2Components.push(target_coin_8);
    cond4_trial2Components.push(cue_coin_8);
    cond4_trial2Components.push(net_shape_8);
    cond4_trial2Components.push(mouse_9);
    cond4_trial2Components.push(fixation_8);
    cond4_trial2Components.push(confirm_net_8);
    cond4_trial2Components.push(net_shape_feedback_4);
    cond4_trial2Components.push(score_text_5);
    
    for (const thisComponent of cond4_trial2Components)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function cond4_trial2RoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'cond4_trial2'-------
    // get current time
    t = cond4_trial2Clock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *target_coin_8* updates
    if (t >= 0.5 && target_coin_8.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      target_coin_8.tStart = t;  // (not accounting for frame time here)
      target_coin_8.frameNStart = frameN;  // exact frame index
      
      target_coin_8.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (target_coin_8.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      target_coin_8.setAutoDraw(false);
    }
    
    // *cue_coin_8* updates
    if (t >= 2.0 && cue_coin_8.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      cue_coin_8.tStart = t;  // (not accounting for frame time here)
      cue_coin_8.frameNStart = frameN;  // exact frame index
      
      cue_coin_8.setAutoDraw(true);
    }

    frameRemains = 2.0 + 0.3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (cue_coin_8.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      cue_coin_8.setAutoDraw(false);
    }
    net_shape_8.pos = mouse_9.getPos();
    
    
    // *net_shape_8* updates
    if (t >= 2.5 && net_shape_8.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_8.tStart = t;  // (not accounting for frame time here)
      net_shape_8.frameNStart = frameN;  // exact frame index
      
      net_shape_8.setAutoDraw(true);
    }

    
    // *fixation_8* updates
    if (t >= 1.5 && fixation_8.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      fixation_8.tStart = t;  // (not accounting for frame time here)
      fixation_8.frameNStart = frameN;  // exact frame index
      
      fixation_8.setAutoDraw(true);
    }

    frameRemains = 1.5 + 0.5 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (fixation_8.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      fixation_8.setAutoDraw(false);
    }
    
    // *confirm_net_8* updates
    if (t >= 2.5 && confirm_net_8.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      confirm_net_8.tStart = t;  // (not accounting for frame time here)
      confirm_net_8.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { confirm_net_8.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_8.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { confirm_net_8.clearEvents(); });
    }

    if (confirm_net_8.status === PsychoJS.Status.STARTED) {
      let theseKeys = confirm_net_8.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _confirm_net_8_allKeys = _confirm_net_8_allKeys.concat(theseKeys);
      if (_confirm_net_8_allKeys.length > 0) {
        confirm_net_8.keys = _confirm_net_8_allKeys[_confirm_net_8_allKeys.length - 1].name;  // just the last key pressed
        confirm_net_8.rt = _confirm_net_8_allKeys[_confirm_net_8_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    //net_shape_feedback_4.pos = mouse_9.getPos();
    difference = (target_coin_posx2 - feedback_net_posx);
    
    rmdiff = Math.sqrt(Math.pow(difference, 2));
    if ((rmdiff < 0.05)) {
        feedback_color = green;
        border_color = green;
    
    } else {
        feedback_color = white;
        border_color = white;
    
    }
    
    
    // *net_shape_feedback_4* updates
    if (t >= 0.5 && net_shape_feedback_4.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      net_shape_feedback_4.tStart = t;  // (not accounting for frame time here)
      net_shape_feedback_4.frameNStart = frameN;  // exact frame index
      
      net_shape_feedback_4.setAutoDraw(true);
    }

    frameRemains = 0.5 + 0.75 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (net_shape_feedback_4.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      net_shape_feedback_4.setAutoDraw(false);
    }
    
    if (net_shape_feedback_4.status === PsychoJS.Status.STARTED){ // only update if being drawn
      net_shape_feedback_4.setFillColor(new util.Color(feedback_color), false);
      net_shape_feedback_4.setLineColor(new util.Color(border_color), false);
    }
    
    // *score_text_5* updates
    if (t >= 0.0 && score_text_5.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      score_text_5.tStart = t;  // (not accounting for frame time here)
      score_text_5.frameNStart = frameN;  // exact frame index
      
      score_text_5.setAutoDraw(true);
    }

    frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
    if (score_text_5.status === PsychoJS.Status.STARTED && t >= frameRemains) {
      score_text_5.setAutoDraw(false);
    }
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of cond4_trial2Components)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function cond4_trial2RoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'cond4_trial2'-------
    for (const thisComponent of cond4_trial2Components) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    participant = expInfo["participant"];
    condition = "Walk";
    cueSD = cue_SD;
    walkSD = walk_SD;
    trials_9.addData("participant", participant);
    trials_9.addData("condition", condition);
    trials_9.addData("cue SD", cueSD);
    trials_9.addData("walk SD", walkSD);
    conditions_3and4.finished = true;
    
    // store data for thisExp (ExperimentHandler)
    _mouseXYs = mouse_9.getPos();
    _mouseButtons = mouse_9.getPressed();
    psychoJS.experiment.addData('mouse_9.x', _mouseXYs[0]);
    psychoJS.experiment.addData('mouse_9.y', _mouseXYs[1]);
    psychoJS.experiment.addData('mouse_9.leftButton', _mouseButtons[0]);
    psychoJS.experiment.addData('mouse_9.midButton', _mouseButtons[1]);
    psychoJS.experiment.addData('mouse_9.rightButton', _mouseButtons[2]);
    if (mouse_9.clicked_name.length > 0) {
      psychoJS.experiment.addData('mouse_9.clicked_name', mouse_9.clicked_name[0]);}
    psychoJS.experiment.addData('confirm_net_8.keys', confirm_net_8.keys);
    if (typeof confirm_net_8.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('confirm_net_8.rt', confirm_net_8.rt);
        routineTimer.reset();
        }
    
    confirm_net_8.stop();
    //net_shape_feedback.setAutoDraw(false);
    net_shape_feedback.pos = mouse_9.getPos()
    trials_9.addData("rmdiff", rmdiff);
    trials_9.addData("feedback_net_posx_trial2onwards",  mouse_9.getPos()[0]);
    
    if ((feedback_color == green)) {
        gains = gains+(100);
    
    } else {
        gains=gains;
    
    }
    score_text_5.setAutoDraw(true);
    // the Routine "cond4_trial2" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _key_resp_3_allKeys;
var End_screenComponents;
function End_screenRoutineBegin(snapshot) {
  return function () {
    //------Prepare to start Routine 'End_screen'-------
    t = 0;
    End_screenClock.reset(); // clock
    frameN = -1;
    continueRoutine = true; // until we're told otherwise
    // update component parameters for each repeat
    key_resp_3.keys = undefined;
    key_resp_3.rt = undefined;
    _key_resp_3_allKeys = [];
    // keep track of which components have finished
    End_screenComponents = [];
    End_screenComponents.push(text_10);
    End_screenComponents.push(key_resp_3);
    
    for (const thisComponent of End_screenComponents)
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
    return Scheduler.Event.NEXT;
  }
}


function End_screenRoutineEachFrame(snapshot) {
  return function () {
    //------Loop for each frame of Routine 'End_screen'-------
    // get current time
    t = End_screenClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text_10* updates
    if (t >= 0.0 && text_10.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_10.tStart = t;  // (not accounting for frame time here)
      text_10.frameNStart = frameN;  // exact frame index
      
      text_10.setAutoDraw(true);
    }

    
    // *key_resp_3* updates
    if (t >= 0.0 && key_resp_3.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp_3.tStart = t;  // (not accounting for frame time here)
      key_resp_3.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp_3.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp_3.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp_3.clearEvents(); });
    }

    if (key_resp_3.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp_3.getKeys({keyList: ['space', 'space'], waitRelease: false});
      _key_resp_3_allKeys = _key_resp_3_allKeys.concat(theseKeys);
      if (_key_resp_3_allKeys.length > 0) {
        key_resp_3.keys = _key_resp_3_allKeys[_key_resp_3_allKeys.length - 1].name;  // just the last key pressed
        key_resp_3.rt = _key_resp_3_allKeys[_key_resp_3_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    for (const thisComponent of End_screenComponents)
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
        break;
      }
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function End_screenRoutineEnd(snapshot) {
  return function () {
    //------Ending Routine 'End_screen'-------
    for (const thisComponent of End_screenComponents) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    }
    psychoJS.experiment.addData('key_resp_3.keys', key_resp_3.keys);
    if (typeof key_resp_3.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp_3.rt', key_resp_3.rt);
        routineTimer.reset();
        }
    
    key_resp_3.stop();
    // the Routine "End_screen" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(scheduler, snapshot) {
  // ------Prepare for next entry------
  return function () {
    if (typeof snapshot !== 'undefined') {
      // ------Check if user ended loop early------
      if (snapshot.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(snapshot);
        }
        scheduler.stop();
      } else {
        const thisTrial = snapshot.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(snapshot);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(currentLoop) {
  return function () {
    psychoJS.importAttributes(currentLoop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
