﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2021.1.0),
    on Tue May 18 12:38:28 2021
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

import psychopy
psychopy.useVersion('latest')


from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2021.1.0'
expName = 'showCoin'  # from the Builder filename that created this script
expInfo = {'participant': '4', 'session': '1'}
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='/Users/lucymckeown/Documents/coinExperiment/showCoin_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.DEBUG)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1440, 900], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "Instr"
InstrClock = core.Clock()
green=[-1,0,-1]
white = [0, 0, 0]
text = visual.TextStim(win=win, name='text',
    text='\n Welcome to the experiment\n\nImagine you are standing in front of a lake and someone is throwing coins into the lake from behind you.\n\nThe first coin lands in the water, followed by a second shortly after. Your job is to guess where the second coin will land once you have seen the landing spot of the first coin. To do this you will need to click and drag the net to the location of your guess.\n\nIt will look something like this (press space to proceed)...\n\n\n',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
instr_resp = keyboard.Keyboard()
cue_coin_posx = 0
cue_coin_posy = 0 

target_coin_posx = 0
target_coin_posy = 0

group ='AB'
conditions = 'conditions'
xlsx = '.xlsx'

if int(expInfo['participant'])%2==0:
    group = 'AB'
    condition1 = 'Press space to begin the first condition'
    condition2 = 'Press space to begin the second condition'
else:
    group = 'BA'
    condition2 = 'Press space to begin the first condition'
    condition1 = 'Press space to begin the second condition'

file_name = conditions+group+xlsx

# Initialize components for Routine "InstrVisual1"
InstrVisual1Clock = core.Clock()
fixation_instr = visual.ShapeStim(
    win=win, name='fixation_instr', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=0.0, interpolate=True)
cue_coin_intstr1 = visual.Polygon(
    win=win, name='cue_coin_intstr1',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=(0.2, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
text_2 = visual.TextStim(win=win, name='text_2',
    text='\nA cross at the centre of the screen will mark the start of each trial.\n\n',
    font='Arial',
    pos=(-0.3, 0.3), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);
key_resp_instr1 = keyboard.Keyboard()
text_5 = visual.TextStim(win=win, name='text_5',
    text='Then the COIN 1 will appear.\n\nPress space to move to the next screen.',
    font='Arial',
    pos=(-0.3, 0.3), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-4.0);

# Initialize components for Routine "InstrVisual2"
InstrVisual2Clock = core.Clock()
text_3 = visual.TextStim(win=win, name='text_3',
    text='\n\n\nThen make a guess at the location of COIN 2 by dragging the NET (the white bar shown here).\nHave a go now.\n\nKeep dragging until it lines up with where you think COIN 2 is and leave the mouse cursor hovering over your guessed location as you press space bar to confirm.\n\nPress space to proceed.',
    font='Arial',
    pos=(-0.3, 0.2), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
net_shape_instr = visual.Rect(
    win=win, name='net_shape_instr',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=(0.4, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-1.0, interpolate=True)
key_resp_instr2 = keyboard.Keyboard()
mouse_3 = event.Mouse(win=win)
x, y = [None, None]
mouse_3.mouseClock = core.Clock()

# Initialize components for Routine "InstrVisual3"
InstrVisual3Clock = core.Clock()
text_4 = visual.TextStim(win=win, name='text_4',
    text='\nThe location of the COIN 2 will then be revealed . Here it is!\n\nPress space to begin the experiment.',
    font='Arial',
    pos=(-0.3, 0.3), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
target_coin_instr = visual.Polygon(
    win=win, name='target_coin_instr',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=(0.4, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
key_resp_instr3 = keyboard.Keyboard()

# Initialize components for Routine "condition0_trial1"
condition0_trial1Clock = core.Clock()
cue_coin_13 = visual.Polygon(
    win=win, name='cue_coin_13',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
mouse_14 = event.Mouse(win=win)
x, y = [None, None]
mouse_14.mouseClock = core.Clock()
confirm_net_13 = keyboard.Keyboard()
fixation_13 = visual.ShapeStim(
    win=win, name='fixation_13', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
net_posx = mouse_14.getPos()[0]
net_posy = mouse_14.getPos()[1]

net_shape_13 = visual.Rect(
    win=win, name='net_shape_13',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)

# Initialize components for Routine "condition0_trial2"
condition0_trial2Clock = core.Clock()
target_coin_3 = visual.Polygon(
    win=win, name='target_coin_3',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
cue_coin_14 = visual.Polygon(
    win=win, name='cue_coin_14',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-2.0, interpolate=True)
net_posx2 = 0
net_posy2 = 0
net_shape_14 = visual.Rect(
    win=win, name='net_shape_14',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1.0, depth=-4.0, interpolate=True)
mouse_15 = event.Mouse(win=win)
x, y = [None, None]
mouse_15.mouseClock = core.Clock()
fixation_14 = visual.ShapeStim(
    win=win, name='fixation_14', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)
confirm_net_14 = keyboard.Keyboard()
feedback_net_posx = mouse_15.getPos()[0]
feedback_net_posy = mouse_15.getPos()[1]
feedback_color = "white"
border_color = "white"
#For target visible after trial ends
#target_color = "red"

#def createTarget(piece):
    #return visual.Circle(win=win, edges=32, fillColor="white", lineColor="red", pos=(0,0), size=0.05, autoDraw=(True))

#def drawPicked(picked):
    #for each in picked:
        #each.draw()
        
#For score
gains = 0
net_shape_feedback_7 = visual.Rect(
    win=win, name='net_shape_feedback_7',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-9.0, interpolate=True)

# Initialize components for Routine "condition_order1"
condition_order1Clock = core.Clock()
text_6 = visual.TextStim(win=win, name='text_6',
    text='default text',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp = keyboard.Keyboard()

# Initialize components for Routine "cond1_trial"
cond1_trialClock = core.Clock()
cue_coin = visual.Polygon(
    win=win, name='cue_coin',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
mouse = event.Mouse(win=win)
x, y = [None, None]
mouse.mouseClock = core.Clock()
confirm_net = keyboard.Keyboard()
fixation = visual.ShapeStim(
    win=win, name='fixation', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
net_posx = mouse.getPos()[0]
net_posy = mouse.getPos()[1]

net_shape = visual.Rect(
    win=win, name='net_shape',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)

# Initialize components for Routine "cond1_trial_2"
cond1_trial_2Clock = core.Clock()
target_coin_2 = visual.Polygon(
    win=win, name='target_coin_2',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
cue_coin_2 = visual.Polygon(
    win=win, name='cue_coin_2',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-2.0, interpolate=True)
net_posx2 = 0
net_posy2 = 0
net_shape_2 = visual.Rect(
    win=win, name='net_shape_2',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1.0, depth=-4.0, interpolate=True)
mouse_2 = event.Mouse(win=win)
x, y = [None, None]
mouse_2.mouseClock = core.Clock()
fixation_2 = visual.ShapeStim(
    win=win, name='fixation_2', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)
confirm_net_2 = keyboard.Keyboard()
feedback_net_posx = mouse.getPos()[0]
feedback_net_posy = mouse.getPos()[1]
feedback_color = "white"
border_color = "white"
#For target visible after trial ends
#target_color = "red"

#def createTarget(piece):
    #return visual.Circle(win=win, edges=32, fillColor="white", lineColor="red", pos=(0,0), size=0.05, autoDraw=(True))

#def drawPicked(picked):
    #for each in picked:
        #each.draw()
        
#For score
gains = 0
net_shape_feedback = visual.Rect(
    win=win, name='net_shape_feedback',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1.0,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=1.0, depth=-9.0, interpolate=True)
score_text_2 = visual.TextStim(win=win, name='score_text_2',
    text='default text',
    font='Open Sans',
    pos=(0.4, 0.4), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-10.0);

# Initialize components for Routine "BreakScreen"
BreakScreenClock = core.Clock()
break_text = visual.TextStim(win=win, name='break_text',
    text='\n\n\nThis is a short break.\n\nPress space when you are ready to continue.\n',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
break_resp = keyboard.Keyboard()

# Initialize components for Routine "cond2_trial1"
cond2_trial1Clock = core.Clock()
cue_coin_3 = visual.Polygon(
    win=win, name='cue_coin_3',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
mouse_4 = event.Mouse(win=win)
x, y = [None, None]
mouse_4.mouseClock = core.Clock()
confirm_net_3 = keyboard.Keyboard()
fixation_3 = visual.ShapeStim(
    win=win, name='fixation_3', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
net_posx = 0
net_posy = 0
net_shape_3 = visual.Rect(
    win=win, name='net_shape_3',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)

# Initialize components for Routine "cond2_trial_2"
cond2_trial_2Clock = core.Clock()
target_coin_4 = visual.Polygon(
    win=win, name='target_coin_4',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
cue_coin_4 = visual.Polygon(
    win=win, name='cue_coin_4',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-2.0, interpolate=True)
net_posx2 = 0
net_posy2 = 0
net_shape_4 = visual.Rect(
    win=win, name='net_shape_4',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
mouse_5 = event.Mouse(win=win)
x, y = [None, None]
mouse_5.mouseClock = core.Clock()
fixation_4 = visual.ShapeStim(
    win=win, name='fixation_4', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)
confirm_net_4 = keyboard.Keyboard()
net_posx = 0
net_posy = 0

feedback_color = "white"
border_color = "white"
net_shape_feedback_2 = visual.Rect(
    win=win, name='net_shape_feedback_2',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=0.7, depth=-9.0, interpolate=True)
score_text_3 = visual.TextStim(win=win, name='score_text_3',
    text='default text',
    font='Open Sans',
    pos=(0.4, 0.4), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-10.0);

# Initialize components for Routine "condition_order2"
condition_order2Clock = core.Clock()
text_7 = visual.TextStim(win=win, name='text_7',
    text='default text',
    font='Open Sans',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp_2 = keyboard.Keyboard()

# Initialize components for Routine "cond3_trial1"
cond3_trial1Clock = core.Clock()
cue_coin_5 = visual.Polygon(
    win=win, name='cue_coin_5',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
mouse_6 = event.Mouse(win=win)
x, y = [None, None]
mouse_6.mouseClock = core.Clock()
confirm_net_6 = keyboard.Keyboard()
fixation_5 = visual.ShapeStim(
    win=win, name='fixation_5', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
net_posx = 0
net_posy = 0

net_shape_5 = visual.Rect(
    win=win, name='net_shape_5',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)

# Initialize components for Routine "cond3_trial2"
cond3_trial2Clock = core.Clock()
target_coin_6 = visual.Polygon(
    win=win, name='target_coin_6',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
cue_coin_6 = visual.Polygon(
    win=win, name='cue_coin_6',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-2.0, interpolate=True)
net_posx2 = 0
net_posy2 = 0
net_shape_6 = visual.Rect(
    win=win, name='net_shape_6',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
mouse_7 = event.Mouse(win=win)
x, y = [None, None]
mouse_7.mouseClock = core.Clock()
fixation_6 = visual.ShapeStim(
    win=win, name='fixation_6', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)
confirm_net_5 = keyboard.Keyboard()
net_posx = 0
net_posy = 0

feedback_color = "white"
border_color = "white"
net_shape_feedback_3 = visual.Rect(
    win=win, name='net_shape_feedback_3',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=0.7, depth=-9.0, interpolate=True)
score_text_4 = visual.TextStim(win=win, name='score_text_4',
    text='default text',
    font='Open Sans',
    pos=(0.4, 0.4), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-10.0);

# Initialize components for Routine "BreakScreen"
BreakScreenClock = core.Clock()
break_text = visual.TextStim(win=win, name='break_text',
    text='\n\n\nThis is a short break.\n\nPress space when you are ready to continue.\n',
    font='Arial',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
break_resp = keyboard.Keyboard()

# Initialize components for Routine "cond4_trial1"
cond4_trial1Clock = core.Clock()
cue_coin_7 = visual.Polygon(
    win=win, name='cue_coin_7',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-1.0, interpolate=True)
mouse_8 = event.Mouse(win=win)
x, y = [None, None]
mouse_8.mouseClock = core.Clock()
confirm_net_7 = keyboard.Keyboard()
fixation_7 = visual.ShapeStim(
    win=win, name='fixation_7', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
net_posx = 0
net_posy = 0
net_shape_7 = visual.Rect(
    win=win, name='net_shape_7',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)

# Initialize components for Routine "cond4_trial2"
cond4_trial2Clock = core.Clock()
target_coin_8 = visual.Polygon(
    win=win, name='target_coin_8',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,0,0], fillColor=[1,0,0],
    opacity=1, depth=-1.0, interpolate=True)
cue_coin_8 = visual.Polygon(
    win=win, name='cue_coin_8',units='height', 
    edges=200, size=(0.05, 0.05),
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,0], fillColor=[1,1,0],
    opacity=1, depth=-2.0, interpolate=True)
net_posx2 = 0
net_posy2 = 0
net_shape_8 = visual.Rect(
    win=win, name='net_shape_8',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-4.0, interpolate=True)
mouse_9 = event.Mouse(win=win)
x, y = [None, None]
mouse_9.mouseClock = core.Clock()
fixation_8 = visual.ShapeStim(
    win=win, name='fixation_8', vertices='cross',
    size=(0.05, 0.05),
    ori=0, pos=(0, 0),
    lineWidth=1,     colorSpace='rgb',  lineColor=[1,1,1], fillColor=[1,1,1],
    opacity=1, depth=-6.0, interpolate=True)
confirm_net_8 = keyboard.Keyboard()
net_posx = 0
net_posy = 0

feedback_color = "white"
border_color = "white"
net_shape_feedback_4 = visual.Rect(
    win=win, name='net_shape_feedback_4',units='height', 
    width=(0.07, 10)[0], height=(0.07, 10)[1],
    ori=0, pos=[0,0],
    lineWidth=1,     colorSpace='rgb',  lineColor='white', fillColor='white',
    opacity=0.7, depth=-9.0, interpolate=True)
score_text_5 = visual.TextStim(win=win, name='score_text_5',
    text='default text',
    font='Open Sans',
    pos=(0.4, 0.4), height=0.05, wrapWidth=None, ori=0.0, 
    color='white', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-10.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "Instr"-------
continueRoutine = True
# update component parameters for each repeat
instr_resp.keys = []
instr_resp.rt = []
_instr_resp_allKeys = []
# keep track of which components have finished
InstrComponents = [text, instr_resp]
for thisComponent in InstrComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
InstrClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "Instr"-------
while continueRoutine:
    # get current time
    t = InstrClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=InstrClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text* updates
    if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        text.setAutoDraw(True)
    
    # *instr_resp* updates
    waitOnFlip = False
    if instr_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instr_resp.frameNStart = frameN  # exact frame index
        instr_resp.tStart = t  # local t and not account for scr refresh
        instr_resp.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instr_resp, 'tStartRefresh')  # time at next scr refresh
        instr_resp.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(instr_resp.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(instr_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if instr_resp.status == STARTED and not waitOnFlip:
        theseKeys = instr_resp.getKeys(keyList=['space', 'space'], waitRelease=False)
        _instr_resp_allKeys.extend(theseKeys)
        if len(_instr_resp_allKeys):
            instr_resp.keys = _instr_resp_allKeys[-1].name  # just the last key pressed
            instr_resp.rt = _instr_resp_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in InstrComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "Instr"-------
for thisComponent in InstrComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text.started', text.tStartRefresh)
thisExp.addData('text.stopped', text.tStopRefresh)
# check responses
if instr_resp.keys in ['', [], None]:  # No response was made
    instr_resp.keys = None
thisExp.addData('instr_resp.keys',instr_resp.keys)
if instr_resp.keys != None:  # we had a response
    thisExp.addData('instr_resp.rt', instr_resp.rt)
thisExp.addData('instr_resp.started', instr_resp.tStartRefresh)
thisExp.addData('instr_resp.stopped', instr_resp.tStopRefresh)
thisExp.nextEntry()
# the Routine "Instr" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "InstrVisual1"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_instr1.keys = []
key_resp_instr1.rt = []
_key_resp_instr1_allKeys = []
# keep track of which components have finished
InstrVisual1Components = [fixation_instr, cue_coin_intstr1, text_2, key_resp_instr1, text_5]
for thisComponent in InstrVisual1Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
InstrVisual1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "InstrVisual1"-------
while continueRoutine:
    # get current time
    t = InstrVisual1Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=InstrVisual1Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *fixation_instr* updates
    if fixation_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        fixation_instr.frameNStart = frameN  # exact frame index
        fixation_instr.tStart = t  # local t and not account for scr refresh
        fixation_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(fixation_instr, 'tStartRefresh')  # time at next scr refresh
        fixation_instr.setAutoDraw(True)
    if fixation_instr.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > fixation_instr.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            fixation_instr.tStop = t  # not accounting for scr refresh
            fixation_instr.frameNStop = frameN  # exact frame index
            win.timeOnFlip(fixation_instr, 'tStopRefresh')  # time at next scr refresh
            fixation_instr.setAutoDraw(False)
    
    # *cue_coin_intstr1* updates
    if cue_coin_intstr1.status == NOT_STARTED and tThisFlip >= 3.5-frameTolerance:
        # keep track of start time/frame for later
        cue_coin_intstr1.frameNStart = frameN  # exact frame index
        cue_coin_intstr1.tStart = t  # local t and not account for scr refresh
        cue_coin_intstr1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(cue_coin_intstr1, 'tStartRefresh')  # time at next scr refresh
        cue_coin_intstr1.setAutoDraw(True)
    
    # *text_2* updates
    if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_2.frameNStart = frameN  # exact frame index
        text_2.tStart = t  # local t and not account for scr refresh
        text_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
        text_2.setAutoDraw(True)
    if text_2.status == STARTED:
        # is it time to stop? (based on global clock, using actual start)
        if tThisFlipGlobal > text_2.tStartRefresh + 3.0-frameTolerance:
            # keep track of stop time/frame for later
            text_2.tStop = t  # not accounting for scr refresh
            text_2.frameNStop = frameN  # exact frame index
            win.timeOnFlip(text_2, 'tStopRefresh')  # time at next scr refresh
            text_2.setAutoDraw(False)
    
    # *key_resp_instr1* updates
    waitOnFlip = False
    if key_resp_instr1.status == NOT_STARTED and tThisFlip >= 3.5-frameTolerance:
        # keep track of start time/frame for later
        key_resp_instr1.frameNStart = frameN  # exact frame index
        key_resp_instr1.tStart = t  # local t and not account for scr refresh
        key_resp_instr1.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_instr1, 'tStartRefresh')  # time at next scr refresh
        key_resp_instr1.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp_instr1.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp_instr1.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp_instr1.status == STARTED and not waitOnFlip:
        theseKeys = key_resp_instr1.getKeys(keyList=['space', 'space'], waitRelease=False)
        _key_resp_instr1_allKeys.extend(theseKeys)
        if len(_key_resp_instr1_allKeys):
            key_resp_instr1.keys = _key_resp_instr1_allKeys[-1].name  # just the last key pressed
            key_resp_instr1.rt = _key_resp_instr1_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # *text_5* updates
    if text_5.status == NOT_STARTED and tThisFlip >= 3.5-frameTolerance:
        # keep track of start time/frame for later
        text_5.frameNStart = frameN  # exact frame index
        text_5.tStart = t  # local t and not account for scr refresh
        text_5.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_5, 'tStartRefresh')  # time at next scr refresh
        text_5.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in InstrVisual1Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "InstrVisual1"-------
for thisComponent in InstrVisual1Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_2.started', text_2.tStartRefresh)
thisExp.addData('text_2.stopped', text_2.tStopRefresh)
# check responses
if key_resp_instr1.keys in ['', [], None]:  # No response was made
    key_resp_instr1.keys = None
thisExp.addData('key_resp_instr1.keys',key_resp_instr1.keys)
if key_resp_instr1.keys != None:  # we had a response
    thisExp.addData('key_resp_instr1.rt', key_resp_instr1.rt)
thisExp.addData('key_resp_instr1.started', key_resp_instr1.tStartRefresh)
thisExp.addData('key_resp_instr1.stopped', key_resp_instr1.tStopRefresh)
thisExp.nextEntry()
thisExp.addData('text_5.started', text_5.tStartRefresh)
thisExp.addData('text_5.stopped', text_5.tStopRefresh)
# the Routine "InstrVisual1" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "InstrVisual2"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_instr2.keys = []
key_resp_instr2.rt = []
_key_resp_instr2_allKeys = []
# setup some python lists for storing info about the mouse_3
gotValidClick = False  # until a click is received
# keep track of which components have finished
InstrVisual2Components = [text_3, net_shape_instr, key_resp_instr2, mouse_3]
for thisComponent in InstrVisual2Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
InstrVisual2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "InstrVisual2"-------
while continueRoutine:
    # get current time
    t = InstrVisual2Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=InstrVisual2Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_3* updates
    if text_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_3.frameNStart = frameN  # exact frame index
        text_3.tStart = t  # local t and not account for scr refresh
        text_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_3, 'tStartRefresh')  # time at next scr refresh
        text_3.setAutoDraw(True)
    
    # *net_shape_instr* updates
    if net_shape_instr.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        net_shape_instr.frameNStart = frameN  # exact frame index
        net_shape_instr.tStart = t  # local t and not account for scr refresh
        net_shape_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(net_shape_instr, 'tStartRefresh')  # time at next scr refresh
        net_shape_instr.setAutoDraw(True)
    
    # *key_resp_instr2* updates
    waitOnFlip = False
    if key_resp_instr2.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp_instr2.frameNStart = frameN  # exact frame index
        key_resp_instr2.tStart = t  # local t and not account for scr refresh
        key_resp_instr2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_instr2, 'tStartRefresh')  # time at next scr refresh
        key_resp_instr2.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp_instr2.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp_instr2.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp_instr2.status == STARTED and not waitOnFlip:
        theseKeys = key_resp_instr2.getKeys(keyList=['space', 'space'], waitRelease=False)
        _key_resp_instr2_allKeys.extend(theseKeys)
        if len(_key_resp_instr2_allKeys):
            key_resp_instr2.keys = _key_resp_instr2_allKeys[-1].name  # just the last key pressed
            key_resp_instr2.rt = _key_resp_instr2_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    net_shape_instr.pos = mouse_3.getPos()
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in InstrVisual2Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "InstrVisual2"-------
for thisComponent in InstrVisual2Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_3.started', text_3.tStartRefresh)
thisExp.addData('text_3.stopped', text_3.tStopRefresh)
# check responses
if key_resp_instr2.keys in ['', [], None]:  # No response was made
    key_resp_instr2.keys = None
thisExp.addData('key_resp_instr2.keys',key_resp_instr2.keys)
if key_resp_instr2.keys != None:  # we had a response
    thisExp.addData('key_resp_instr2.rt', key_resp_instr2.rt)
thisExp.addData('key_resp_instr2.started', key_resp_instr2.tStartRefresh)
thisExp.addData('key_resp_instr2.stopped', key_resp_instr2.tStopRefresh)
thisExp.nextEntry()
# store data for thisExp (ExperimentHandler)
thisExp.addData('mouse_3.started', mouse_3.tStart)
thisExp.addData('mouse_3.stopped', mouse_3.tStop)
thisExp.nextEntry()
# the Routine "InstrVisual2" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "InstrVisual3"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_instr3.keys = []
key_resp_instr3.rt = []
_key_resp_instr3_allKeys = []
# keep track of which components have finished
InstrVisual3Components = [text_4, target_coin_instr, key_resp_instr3]
for thisComponent in InstrVisual3Components:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
InstrVisual3Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "InstrVisual3"-------
while continueRoutine:
    # get current time
    t = InstrVisual3Clock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=InstrVisual3Clock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_4* updates
    if text_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_4.frameNStart = frameN  # exact frame index
        text_4.tStart = t  # local t and not account for scr refresh
        text_4.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_4, 'tStartRefresh')  # time at next scr refresh
        text_4.setAutoDraw(True)
    
    # *target_coin_instr* updates
    if target_coin_instr.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
        # keep track of start time/frame for later
        target_coin_instr.frameNStart = frameN  # exact frame index
        target_coin_instr.tStart = t  # local t and not account for scr refresh
        target_coin_instr.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(target_coin_instr, 'tStartRefresh')  # time at next scr refresh
        target_coin_instr.setAutoDraw(True)
    
    # *key_resp_instr3* updates
    waitOnFlip = False
    if key_resp_instr3.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp_instr3.frameNStart = frameN  # exact frame index
        key_resp_instr3.tStart = t  # local t and not account for scr refresh
        key_resp_instr3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_instr3, 'tStartRefresh')  # time at next scr refresh
        key_resp_instr3.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp_instr3.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp_instr3.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp_instr3.status == STARTED and not waitOnFlip:
        theseKeys = key_resp_instr3.getKeys(keyList=['space', 'space'], waitRelease=False)
        _key_resp_instr3_allKeys.extend(theseKeys)
        if len(_key_resp_instr3_allKeys):
            key_resp_instr3.keys = _key_resp_instr3_allKeys[-1].name  # just the last key pressed
            key_resp_instr3.rt = _key_resp_instr3_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in InstrVisual3Components:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "InstrVisual3"-------
for thisComponent in InstrVisual3Components:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_4.started', text_4.tStartRefresh)
thisExp.addData('text_4.stopped', text_4.tStopRefresh)
# check responses
if key_resp_instr3.keys in ['', [], None]:  # No response was made
    key_resp_instr3.keys = None
thisExp.addData('key_resp_instr3.keys',key_resp_instr3.keys)
if key_resp_instr3.keys != None:  # we had a response
    thisExp.addData('key_resp_instr3.rt', key_resp_instr3.rt)
thisExp.addData('key_resp_instr3.started', key_resp_instr3.tStartRefresh)
thisExp.addData('key_resp_instr3.stopped', key_resp_instr3.tStopRefresh)
thisExp.nextEntry()
# the Routine "InstrVisual3" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials_0ab = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('0.01_CueSD_walk.xlsx'),
    seed=None, name='trials_0ab')
thisExp.addLoop(trials_0ab)  # add the loop to the experiment
thisTrials_0ab = trials_0ab.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrials_0ab.rgb)
if thisTrials_0ab != None:
    for paramName in thisTrials_0ab:
        exec('{} = thisTrials_0ab[paramName]'.format(paramName))

for thisTrials_0ab in trials_0ab:
    currentLoop = trials_0ab
    # abbreviate parameter names if possible (e.g. rgb = thisTrials_0ab.rgb)
    if thisTrials_0ab != None:
        for paramName in thisTrials_0ab:
            exec('{} = thisTrials_0ab[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    trials = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(Cond0_Trial1),
        seed=None, name='trials')
    thisExp.addLoop(trials)  # add the loop to the experiment
    thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    for thisTrial in trials:
        currentLoop = trials
        # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
        if thisTrial != None:
            for paramName in thisTrial:
                exec('{} = thisTrial[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "condition0_trial1"-------
        continueRoutine = True
        # update component parameters for each repeat
        cue_coin_13.setPos((cue_coin_posx, cue_coin_posy))
        # setup some python lists for storing info about the mouse_14
        gotValidClick = False  # until a click is received
        confirm_net_13.keys = []
        confirm_net_13.rt = []
        _confirm_net_13_allKeys = []
        net_shape_13.setPos((net_posx, net_posy))
        # keep track of which components have finished
        condition0_trial1Components = [cue_coin_13, mouse_14, confirm_net_13, fixation_13, net_shape_13]
        for thisComponent in condition0_trial1Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        condition0_trial1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "condition0_trial1"-------
        while continueRoutine:
            # get current time
            t = condition0_trial1Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=condition0_trial1Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *cue_coin_13* updates
            if cue_coin_13.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                cue_coin_13.frameNStart = frameN  # exact frame index
                cue_coin_13.tStart = t  # local t and not account for scr refresh
                cue_coin_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(cue_coin_13, 'tStartRefresh')  # time at next scr refresh
                cue_coin_13.setAutoDraw(True)
            if cue_coin_13.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > cue_coin_13.tStartRefresh + 0.3-frameTolerance:
                    # keep track of stop time/frame for later
                    cue_coin_13.tStop = t  # not accounting for scr refresh
                    cue_coin_13.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(cue_coin_13, 'tStopRefresh')  # time at next scr refresh
                    cue_coin_13.setAutoDraw(False)
            
            # *confirm_net_13* updates
            waitOnFlip = False
            if confirm_net_13.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                # keep track of start time/frame for later
                confirm_net_13.frameNStart = frameN  # exact frame index
                confirm_net_13.tStart = t  # local t and not account for scr refresh
                confirm_net_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(confirm_net_13, 'tStartRefresh')  # time at next scr refresh
                confirm_net_13.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(confirm_net_13.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(confirm_net_13.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if confirm_net_13.status == STARTED and not waitOnFlip:
                theseKeys = confirm_net_13.getKeys(keyList=['space', 'space'], waitRelease=False)
                _confirm_net_13_allKeys.extend(theseKeys)
                if len(_confirm_net_13_allKeys):
                    confirm_net_13.keys = _confirm_net_13_allKeys[-1].name  # just the last key pressed
                    confirm_net_13.rt = _confirm_net_13_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # *fixation_13* updates
            if fixation_13.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                fixation_13.frameNStart = frameN  # exact frame index
                fixation_13.tStart = t  # local t and not account for scr refresh
                fixation_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_13, 'tStartRefresh')  # time at next scr refresh
                fixation_13.setAutoDraw(True)
            if fixation_13.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fixation_13.tStartRefresh + 0.5-frameTolerance:
                    # keep track of stop time/frame for later
                    fixation_13.tStop = t  # not accounting for scr refresh
                    fixation_13.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_13, 'tStopRefresh')  # time at next scr refresh
                    fixation_13.setAutoDraw(False)
            net_shape_13.pos = mouse_14.getPos()
            
            
            # *net_shape_13* updates
            if net_shape_13.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                # keep track of start time/frame for later
                net_shape_13.frameNStart = frameN  # exact frame index
                net_shape_13.tStart = t  # local t and not account for scr refresh
                net_shape_13.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(net_shape_13, 'tStartRefresh')  # time at next scr refresh
                net_shape_13.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in condition0_trial1Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "condition0_trial1"-------
        for thisComponent in condition0_trial1Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        participant = expInfo['participant']
        condition = 'Walk'
        cueSD = cue_SD
        walkSD = prior_SD
        trials.addData('participant', participant)
        trials.addData('condition', condition)
        trials.addData('cue SD', cueSD)
        trials.addData('walk SD', walkSD)
        trials.finished = True
        # store data for trials (TrialHandler)
        x, y = mouse_14.getPos()
        buttons = mouse_14.getPressed()
        trials.addData('mouse_14.x', x)
        trials.addData('mouse_14.y', y)
        trials.addData('mouse_14.leftButton', buttons[0])
        trials.addData('mouse_14.midButton', buttons[1])
        trials.addData('mouse_14.rightButton', buttons[2])
        # check responses
        if confirm_net_13.keys in ['', [], None]:  # No response was made
            confirm_net_13.keys = None
        trials.addData('confirm_net_13.keys',confirm_net_13.keys)
        if confirm_net_13.keys != None:  # we had a response
            trials.addData('confirm_net_13.rt', confirm_net_13.rt)
        net_shape_feedback.pos = mouse.getPos()
        trials.addData('feedback_net_posx_trial1',  mouse_14.getPos()[0])
        
        # the Routine "condition0_trial1" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 1.0 repeats of 'trials'
    
    
    # set up handler to look after randomisation of conditions etc
    trials_0 = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(Cond0_Trial2andBeyond),
        seed=None, name='trials_0')
    thisExp.addLoop(trials_0)  # add the loop to the experiment
    thisTrial_0 = trials_0.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_0.rgb)
    if thisTrial_0 != None:
        for paramName in thisTrial_0:
            exec('{} = thisTrial_0[paramName]'.format(paramName))
    
    for thisTrial_0 in trials_0:
        currentLoop = trials_0
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_0.rgb)
        if thisTrial_0 != None:
            for paramName in thisTrial_0:
                exec('{} = thisTrial_0[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "condition0_trial2"-------
        continueRoutine = True
        # update component parameters for each repeat
        target_coin_3.setPos((target_coin_posx2, target_coin_posy2))
        cue_coin_14.setPos((cue_coin_posx2, cue_coin_posy2))
        net_shape_14.setPos((net_posx2, net_posy2))
        # setup some python lists for storing info about the mouse_15
        mouse_15.clicked_name = []
        gotValidClick = False  # until a click is received
        confirm_net_14.keys = []
        confirm_net_14.rt = []
        _confirm_net_14_allKeys = []
        feedback_net_posx = mouse_15.getPos()[0]
        feedback_net_posy = mouse_15.getPos()[1]
        
        #For score
        #if trials_0.thisN==0:
           #number_correct = 0
        #score_text_6.setAutoDraw(True)
        
        #For target left on screen
        #picked = []
        #pieces = [target_coin_2]
        #newTarget = None
        #target_coin_2.setAutoDraw(True)
        
        
        net_shape_feedback_7.setPos((feedback_net_posx, feedback_net_posy ))
        # keep track of which components have finished
        condition0_trial2Components = [target_coin_3, cue_coin_14, net_shape_14, mouse_15, fixation_14, confirm_net_14, net_shape_feedback_7]
        for thisComponent in condition0_trial2Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        condition0_trial2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "condition0_trial2"-------
        while continueRoutine:
            # get current time
            t = condition0_trial2Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=condition0_trial2Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *target_coin_3* updates
            if target_coin_3.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                target_coin_3.frameNStart = frameN  # exact frame index
                target_coin_3.tStart = t  # local t and not account for scr refresh
                target_coin_3.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(target_coin_3, 'tStartRefresh')  # time at next scr refresh
                target_coin_3.setAutoDraw(True)
            if target_coin_3.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > target_coin_3.tStartRefresh + 0.75-frameTolerance:
                    # keep track of stop time/frame for later
                    target_coin_3.tStop = t  # not accounting for scr refresh
                    target_coin_3.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(target_coin_3, 'tStopRefresh')  # time at next scr refresh
                    target_coin_3.setAutoDraw(False)
            
            # *cue_coin_14* updates
            if cue_coin_14.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
                # keep track of start time/frame for later
                cue_coin_14.frameNStart = frameN  # exact frame index
                cue_coin_14.tStart = t  # local t and not account for scr refresh
                cue_coin_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(cue_coin_14, 'tStartRefresh')  # time at next scr refresh
                cue_coin_14.setAutoDraw(True)
            if cue_coin_14.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > cue_coin_14.tStartRefresh + 0.3-frameTolerance:
                    # keep track of stop time/frame for later
                    cue_coin_14.tStop = t  # not accounting for scr refresh
                    cue_coin_14.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(cue_coin_14, 'tStopRefresh')  # time at next scr refresh
                    cue_coin_14.setAutoDraw(False)
            net_shape_14.pos = mouse_15.getPos()
            
            # *net_shape_14* updates
            if net_shape_14.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                # keep track of start time/frame for later
                net_shape_14.frameNStart = frameN  # exact frame index
                net_shape_14.tStart = t  # local t and not account for scr refresh
                net_shape_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(net_shape_14, 'tStartRefresh')  # time at next scr refresh
                net_shape_14.setAutoDraw(True)
            
            # *fixation_14* updates
            if fixation_14.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                # keep track of start time/frame for later
                fixation_14.frameNStart = frameN  # exact frame index
                fixation_14.tStart = t  # local t and not account for scr refresh
                fixation_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fixation_14, 'tStartRefresh')  # time at next scr refresh
                fixation_14.setAutoDraw(True)
            if fixation_14.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fixation_14.tStartRefresh + 0.5-frameTolerance:
                    # keep track of stop time/frame for later
                    fixation_14.tStop = t  # not accounting for scr refresh
                    fixation_14.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fixation_14, 'tStopRefresh')  # time at next scr refresh
                    fixation_14.setAutoDraw(False)
            
            # *confirm_net_14* updates
            waitOnFlip = False
            if confirm_net_14.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                # keep track of start time/frame for later
                confirm_net_14.frameNStart = frameN  # exact frame index
                confirm_net_14.tStart = t  # local t and not account for scr refresh
                confirm_net_14.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(confirm_net_14, 'tStartRefresh')  # time at next scr refresh
                confirm_net_14.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(confirm_net_14.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(confirm_net_14.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if confirm_net_14.status == STARTED and not waitOnFlip:
                theseKeys = confirm_net_14.getKeys(keyList=['space', 'space'], waitRelease=False)
                _confirm_net_14_allKeys.extend(theseKeys)
                if len(_confirm_net_14_allKeys):
                    confirm_net_14.keys = _confirm_net_14_allKeys[-1].name  # just the last key pressed
                    confirm_net_14.rt = _confirm_net_14_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            difference = target_coin_posx2 - feedback_net_posx
            rmdiff = sqrt(difference**2)
                
            if rmdiff  < 0.05:
                feedback_color = "green"
                border_color = "green"
                net_shape_feedback.opacity = 0.7
               
            else:
                feedback_color= "white"
                border_color = "white"
                net_shape_feedback.opacity = 0.7
                
            #For target left on screen
            #from psychopy.hardware import keyboard
            #from psychopy import core
            #kb = keyboard.Keyboard()
            #keys = kb.getKeys(['space'], waitRelease=True)
            #for piece in pieces:
                #if 'space' in keys and newTarget == None:
                    #newTarget = createTarget(piece)
                    #newTarget.pos = target_coin_2.pos
                    #picked.append(newTarget)
            
            #drawPicked(picked)
            
            # *net_shape_feedback_7* updates
            if net_shape_feedback_7.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                # keep track of start time/frame for later
                net_shape_feedback_7.frameNStart = frameN  # exact frame index
                net_shape_feedback_7.tStart = t  # local t and not account for scr refresh
                net_shape_feedback_7.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(net_shape_feedback_7, 'tStartRefresh')  # time at next scr refresh
                net_shape_feedback_7.setAutoDraw(True)
            if net_shape_feedback_7.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > net_shape_feedback_7.tStartRefresh + 0.75-frameTolerance:
                    # keep track of stop time/frame for later
                    net_shape_feedback_7.tStop = t  # not accounting for scr refresh
                    net_shape_feedback_7.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(net_shape_feedback_7, 'tStopRefresh')  # time at next scr refresh
                    net_shape_feedback_7.setAutoDraw(False)
            if net_shape_feedback_7.status == STARTED:  # only update if drawing
                net_shape_feedback_7.setFillColor(feedback_color)
                net_shape_feedback_7.setOpacity(0.7)
                net_shape_feedback_7.setContrast(1.0)
                net_shape_feedback_7.setLineColor(border_color)
                net_shape_feedback_7.setLineWidth(1)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in condition0_trial2Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "condition0_trial2"-------
        for thisComponent in condition0_trial2Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        participant = expInfo['participant']
        condition = 'Walk'
        cueSD = cue_SD
        walkSD = prior_SD
        trials_0.addData('participant', participant)
        trials_0.addData('condition', condition)
        trials_0.addData('cue SD', cueSD)
        trials_0.addData('walk SD', walkSD)
        # store data for trials_0 (TrialHandler)
        x, y = mouse_15.getPos()
        buttons = mouse_15.getPressed()
        if sum(buttons):
            # check if the mouse was inside our 'clickable' objects
            gotValidClick = False
            for obj in [net_shape]:
                if obj.contains(mouse_15):
                    gotValidClick = True
                    mouse_15.clicked_name.append(obj.name)
        trials_0.addData('mouse_15.x', x)
        trials_0.addData('mouse_15.y', y)
        trials_0.addData('mouse_15.leftButton', buttons[0])
        trials_0.addData('mouse_15.midButton', buttons[1])
        trials_0.addData('mouse_15.rightButton', buttons[2])
        if len(mouse_15.clicked_name):
            trials_0.addData('mouse_15.clicked_name', mouse_15.clicked_name[0])
        trials_0.addData('fixation_14.started', fixation_14.tStartRefresh)
        trials_0.addData('fixation_14.stopped', fixation_14.tStopRefresh)
        # check responses
        if confirm_net_14.keys in ['', [], None]:  # No response was made
            confirm_net_14.keys = None
        trials_0.addData('confirm_net_14.keys',confirm_net_14.keys)
        if confirm_net_14.keys != None:  # we had a response
            trials_0.addData('confirm_net_14.rt', confirm_net_14.rt)
        net_shape_feedback_7.pos = mouse_15.getPos()
        trials_0.addData('rmdiff', rmdiff)
        trials_0.addData('feedback_net_posx', feedback_net_posx)
        
        trials_0.addData('rmdiff', rmdiff)
        trials_0.addData('feedback_net_posx_trial2onwards',  mouse_15.getPos()[0])
        
        #For score
        
        if feedback_color == "green":
            gains = gains+(100)
        else:
            gains=gains
        #score_text_0.setAutoDraw(True)
        #trials_0.addData('gains', gains)
        
        #For target left on screen
        #target_color = "white"
        #target_coin_2.setAutoDraw(True)
        #trials_2.addData('mouse_previous',mouse_previous )
        # the Routine "condition0_trial2" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        thisExp.nextEntry()
        
    # completed 1.0 repeats of 'trials_0'
    
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'trials_0ab'


# set up handler to look after randomisation of conditions etc
controlTaskOrder = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions(file_name),
    seed=None, name='controlTaskOrder')
thisExp.addLoop(controlTaskOrder)  # add the loop to the experiment
thisControlTaskOrder = controlTaskOrder.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisControlTaskOrder.rgb)
if thisControlTaskOrder != None:
    for paramName in thisControlTaskOrder:
        exec('{} = thisControlTaskOrder[paramName]'.format(paramName))

for thisControlTaskOrder in controlTaskOrder:
    currentLoop = controlTaskOrder
    # abbreviate parameter names if possible (e.g. rgb = thisControlTaskOrder.rgb)
    if thisControlTaskOrder != None:
        for paramName in thisControlTaskOrder:
            exec('{} = thisControlTaskOrder[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    conditions_1and2 = data.TrialHandler(nReps=nRepsTask1, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('cueSD0.05_0.1.xlsx'),
        seed=None, name='conditions_1and2')
    thisExp.addLoop(conditions_1and2)  # add the loop to the experiment
    thisConditions_1and2 = conditions_1and2.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisConditions_1and2.rgb)
    if thisConditions_1and2 != None:
        for paramName in thisConditions_1and2:
            exec('{} = thisConditions_1and2[paramName]'.format(paramName))
    
    for thisConditions_1and2 in conditions_1and2:
        currentLoop = conditions_1and2
        # abbreviate parameter names if possible (e.g. rgb = thisConditions_1and2.rgb)
        if thisConditions_1and2 != None:
            for paramName in thisConditions_1and2:
                exec('{} = thisConditions_1and2[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "condition_order1"-------
        continueRoutine = True
        # update component parameters for each repeat
        text_6.setText(condition1)
        key_resp.keys = []
        key_resp.rt = []
        _key_resp_allKeys = []
        if int(expInfo['participant'])%2==0:
            condition1 = 'Press space to begin the first condition'
            condition2 = 'Press space to begin the second condition'
        else:
            condition1 = 'Press space to begin the second condition'
            condition2 = 'Press space to begin the first condition'
        # keep track of which components have finished
        condition_order1Components = [text_6, key_resp]
        for thisComponent in condition_order1Components:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        condition_order1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "condition_order1"-------
        while continueRoutine:
            # get current time
            t = condition_order1Clock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=condition_order1Clock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *text_6* updates
            if text_6.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                text_6.frameNStart = frameN  # exact frame index
                text_6.tStart = t  # local t and not account for scr refresh
                text_6.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(text_6, 'tStartRefresh')  # time at next scr refresh
                text_6.setAutoDraw(True)
            
            # *key_resp* updates
            waitOnFlip = False
            if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_resp.frameNStart = frameN  # exact frame index
                key_resp.tStart = t  # local t and not account for scr refresh
                key_resp.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
                key_resp.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_resp.status == STARTED and not waitOnFlip:
                theseKeys = key_resp.getKeys(keyList=['space'], waitRelease=False)
                _key_resp_allKeys.extend(theseKeys)
                if len(_key_resp_allKeys):
                    key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                    key_resp.rt = _key_resp_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in condition_order1Components:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "condition_order1"-------
        for thisComponent in condition_order1Components:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        conditions_1and2.addData('text_6.started', text_6.tStartRefresh)
        conditions_1and2.addData('text_6.stopped', text_6.tStopRefresh)
        # check responses
        if key_resp.keys in ['', [], None]:  # No response was made
            key_resp.keys = None
        conditions_1and2.addData('key_resp.keys',key_resp.keys)
        if key_resp.keys != None:  # we had a response
            conditions_1and2.addData('key_resp.rt', key_resp.rt)
        conditions_1and2.addData('key_resp.started', key_resp.tStartRefresh)
        conditions_1and2.addData('key_resp.stopped', key_resp.tStopRefresh)
        # the Routine "condition_order1" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        trials_1 = data.TrialHandler(nReps=1.0, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond5Trial1),
            seed=None, name='trials_1')
        thisExp.addLoop(trials_1)  # add the loop to the experiment
        thisTrial_1 = trials_1.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_1.rgb)
        if thisTrial_1 != None:
            for paramName in thisTrial_1:
                exec('{} = thisTrial_1[paramName]'.format(paramName))
        
        for thisTrial_1 in trials_1:
            currentLoop = trials_1
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_1.rgb)
            if thisTrial_1 != None:
                for paramName in thisTrial_1:
                    exec('{} = thisTrial_1[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond1_trial"-------
            continueRoutine = True
            # update component parameters for each repeat
            cue_coin.setPos((cue_coin_posx, cue_coin_posy))
            # setup some python lists for storing info about the mouse
            gotValidClick = False  # until a click is received
            confirm_net.keys = []
            confirm_net.rt = []
            _confirm_net_allKeys = []
            net_shape.setPos((net_posx, net_posy))
            # keep track of which components have finished
            cond1_trialComponents = [cue_coin, mouse, confirm_net, fixation, net_shape]
            for thisComponent in cond1_trialComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond1_trialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond1_trial"-------
            while continueRoutine:
                # get current time
                t = cond1_trialClock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond1_trialClock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *cue_coin* updates
                if cue_coin.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin.frameNStart = frameN  # exact frame index
                    cue_coin.tStart = t  # local t and not account for scr refresh
                    cue_coin.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin, 'tStartRefresh')  # time at next scr refresh
                    cue_coin.setAutoDraw(True)
                if cue_coin.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin.tStop = t  # not accounting for scr refresh
                        cue_coin.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin, 'tStopRefresh')  # time at next scr refresh
                        cue_coin.setAutoDraw(False)
                
                # *confirm_net* updates
                waitOnFlip = False
                if confirm_net.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net.frameNStart = frameN  # exact frame index
                    confirm_net.tStart = t  # local t and not account for scr refresh
                    confirm_net.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net, 'tStartRefresh')  # time at next scr refresh
                    confirm_net.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_allKeys.extend(theseKeys)
                    if len(_confirm_net_allKeys):
                        confirm_net.keys = _confirm_net_allKeys[-1].name  # just the last key pressed
                        confirm_net.rt = _confirm_net_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *fixation* updates
                if fixation.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    fixation.frameNStart = frameN  # exact frame index
                    fixation.tStart = t  # local t and not account for scr refresh
                    fixation.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation, 'tStartRefresh')  # time at next scr refresh
                    fixation.setAutoDraw(True)
                if fixation.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation.tStop = t  # not accounting for scr refresh
                        fixation.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation, 'tStopRefresh')  # time at next scr refresh
                        fixation.setAutoDraw(False)
                net_shape.pos = mouse.getPos()
                
                
                # *net_shape* updates
                if net_shape.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape.frameNStart = frameN  # exact frame index
                    net_shape.tStart = t  # local t and not account for scr refresh
                    net_shape.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape, 'tStartRefresh')  # time at next scr refresh
                    net_shape.setAutoDraw(True)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond1_trialComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond1_trial"-------
            for thisComponent in cond1_trialComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_1.addData('participant', participant)
            trials_1.addData('condition', condition)
            trials_1.addData('cue SD', cueSD)
            trials_1.addData('walk SD', walkSD)
            trials_1.finished = True
            # store data for trials_1 (TrialHandler)
            x, y = mouse.getPos()
            buttons = mouse.getPressed()
            trials_1.addData('mouse.x', x)
            trials_1.addData('mouse.y', y)
            trials_1.addData('mouse.leftButton', buttons[0])
            trials_1.addData('mouse.midButton', buttons[1])
            trials_1.addData('mouse.rightButton', buttons[2])
            # check responses
            if confirm_net.keys in ['', [], None]:  # No response was made
                confirm_net.keys = None
            trials_1.addData('confirm_net.keys',confirm_net.keys)
            if confirm_net.keys != None:  # we had a response
                trials_1.addData('confirm_net.rt', confirm_net.rt)
            net_shape_feedback.pos = mouse.getPos()
            # the Routine "cond1_trial" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1.0 repeats of 'trials_1'
        
        
        # set up handler to look after randomisation of conditions etc
        trials_2 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond5Trial2andBeyond),
            seed=None, name='trials_2')
        thisExp.addLoop(trials_2)  # add the loop to the experiment
        thisTrial_2 = trials_2.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
        if thisTrial_2 != None:
            for paramName in thisTrial_2:
                exec('{} = thisTrial_2[paramName]'.format(paramName))
        
        for thisTrial_2 in trials_2:
            currentLoop = trials_2
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
            if thisTrial_2 != None:
                for paramName in thisTrial_2:
                    exec('{} = thisTrial_2[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond1_trial_2"-------
            continueRoutine = True
            # update component parameters for each repeat
            target_coin_2.setPos((target_coin_posx2, target_coin_posy2))
            cue_coin_2.setPos((cue_coin_posx2, cue_coin_posy2))
            net_shape_2.setPos((net_posx2, net_posy2))
            # setup some python lists for storing info about the mouse_2
            mouse_2.clicked_name = []
            gotValidClick = False  # until a click is received
            confirm_net_2.keys = []
            confirm_net_2.rt = []
            _confirm_net_2_allKeys = []
            feedback_net_posx = mouse.getPos()[0]
            feedback_net_posy = mouse.getPos()[1]
            
            #For score
            #if trials_2.thisN==0:
               #number_correct = 0
            score_text_2.setAutoDraw(True)
            
            #For target left on screen
            #picked = []
            #pieces = [target_coin_2]
            #newTarget = None
            #target_coin_2.setAutoDraw(True)
            
            
            net_shape_feedback.setPos((feedback_net_posx, feedback_net_posy ))
            score_text_2.setText(gains)
            # keep track of which components have finished
            cond1_trial_2Components = [target_coin_2, cue_coin_2, net_shape_2, mouse_2, fixation_2, confirm_net_2, net_shape_feedback, score_text_2]
            for thisComponent in cond1_trial_2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond1_trial_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond1_trial_2"-------
            while continueRoutine:
                # get current time
                t = cond1_trial_2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond1_trial_2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *target_coin_2* updates
                if target_coin_2.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    target_coin_2.frameNStart = frameN  # exact frame index
                    target_coin_2.tStart = t  # local t and not account for scr refresh
                    target_coin_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(target_coin_2, 'tStartRefresh')  # time at next scr refresh
                    target_coin_2.setAutoDraw(True)
                if target_coin_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > target_coin_2.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        target_coin_2.tStop = t  # not accounting for scr refresh
                        target_coin_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(target_coin_2, 'tStopRefresh')  # time at next scr refresh
                        target_coin_2.setAutoDraw(False)
                
                # *cue_coin_2* updates
                if cue_coin_2.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_2.frameNStart = frameN  # exact frame index
                    cue_coin_2.tStart = t  # local t and not account for scr refresh
                    cue_coin_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_2, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_2.setAutoDraw(True)
                if cue_coin_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_2.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_2.tStop = t  # not accounting for scr refresh
                        cue_coin_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_2, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_2.setAutoDraw(False)
                net_shape_2.pos = mouse_2.getPos()
                
                # *net_shape_2* updates
                if net_shape_2.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_2.frameNStart = frameN  # exact frame index
                    net_shape_2.tStart = t  # local t and not account for scr refresh
                    net_shape_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_2, 'tStartRefresh')  # time at next scr refresh
                    net_shape_2.setAutoDraw(True)
                
                # *fixation_2* updates
                if fixation_2.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_2.frameNStart = frameN  # exact frame index
                    fixation_2.tStart = t  # local t and not account for scr refresh
                    fixation_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_2, 'tStartRefresh')  # time at next scr refresh
                    fixation_2.setAutoDraw(True)
                if fixation_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_2.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_2.tStop = t  # not accounting for scr refresh
                        fixation_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_2, 'tStopRefresh')  # time at next scr refresh
                        fixation_2.setAutoDraw(False)
                
                # *confirm_net_2* updates
                waitOnFlip = False
                if confirm_net_2.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_2.frameNStart = frameN  # exact frame index
                    confirm_net_2.tStart = t  # local t and not account for scr refresh
                    confirm_net_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_2, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_2.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_2.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_2.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_2.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_2_allKeys.extend(theseKeys)
                    if len(_confirm_net_2_allKeys):
                        confirm_net_2.keys = _confirm_net_2_allKeys[-1].name  # just the last key pressed
                        confirm_net_2.rt = _confirm_net_2_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                difference = target_coin_posx2 - feedback_net_posx
                rmdiff = sqrt(difference**2)
                    
                if rmdiff  < 0.05:
                    feedback_color = "green"
                    border_color = "green"
                    net_shape_feedback.opacity = 0.7
                   
                else:
                    feedback_color= "white"
                    border_color = "white"
                    net_shape_feedback.opacity = 0.7
                    
                #For target left on screen
                #from psychopy.hardware import keyboard
                #from psychopy import core
                #kb = keyboard.Keyboard()
                #keys = kb.getKeys(['space'], waitRelease=True)
                #for piece in pieces:
                    #if 'space' in keys and newTarget == None:
                        #newTarget = createTarget(piece)
                        #newTarget.pos = target_coin_2.pos
                        #picked.append(newTarget)
                
                #drawPicked(picked)
                
                # *net_shape_feedback* updates
                if net_shape_feedback.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_feedback.frameNStart = frameN  # exact frame index
                    net_shape_feedback.tStart = t  # local t and not account for scr refresh
                    net_shape_feedback.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_feedback, 'tStartRefresh')  # time at next scr refresh
                    net_shape_feedback.setAutoDraw(True)
                if net_shape_feedback.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > net_shape_feedback.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        net_shape_feedback.tStop = t  # not accounting for scr refresh
                        net_shape_feedback.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(net_shape_feedback, 'tStopRefresh')  # time at next scr refresh
                        net_shape_feedback.setAutoDraw(False)
                if net_shape_feedback.status == STARTED:  # only update if drawing
                    net_shape_feedback.setFillColor(feedback_color)
                    net_shape_feedback.setOpacity(0.7)
                    net_shape_feedback.setContrast(1.0)
                    net_shape_feedback.setLineColor(border_color)
                    net_shape_feedback.setLineWidth(1)
                
                # *score_text_2* updates
                if score_text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    score_text_2.frameNStart = frameN  # exact frame index
                    score_text_2.tStart = t  # local t and not account for scr refresh
                    score_text_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(score_text_2, 'tStartRefresh')  # time at next scr refresh
                    score_text_2.setAutoDraw(True)
                if score_text_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > score_text_2.tStartRefresh + 1.0-frameTolerance:
                        # keep track of stop time/frame for later
                        score_text_2.tStop = t  # not accounting for scr refresh
                        score_text_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(score_text_2, 'tStopRefresh')  # time at next scr refresh
                        score_text_2.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond1_trial_2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond1_trial_2"-------
            for thisComponent in cond1_trial_2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_2.addData('participant', participant)
            trials_2.addData('condition', condition)
            trials_2.addData('cue SD', cueSD)
            trials_2.addData('walk SD', walkSD)
            # store data for trials_2 (TrialHandler)
            x, y = mouse_2.getPos()
            buttons = mouse_2.getPressed()
            if sum(buttons):
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [net_shape]:
                    if obj.contains(mouse_2):
                        gotValidClick = True
                        mouse_2.clicked_name.append(obj.name)
            trials_2.addData('mouse_2.x', x)
            trials_2.addData('mouse_2.y', y)
            trials_2.addData('mouse_2.leftButton', buttons[0])
            trials_2.addData('mouse_2.midButton', buttons[1])
            trials_2.addData('mouse_2.rightButton', buttons[2])
            if len(mouse_2.clicked_name):
                trials_2.addData('mouse_2.clicked_name', mouse_2.clicked_name[0])
            trials_2.addData('fixation_2.started', fixation_2.tStartRefresh)
            trials_2.addData('fixation_2.stopped', fixation_2.tStopRefresh)
            # check responses
            if confirm_net_2.keys in ['', [], None]:  # No response was made
                confirm_net_2.keys = None
            trials_2.addData('confirm_net_2.keys',confirm_net_2.keys)
            if confirm_net_2.keys != None:  # we had a response
                trials_2.addData('confirm_net_2.rt', confirm_net_2.rt)
            net_shape_feedback.pos = mouse_2.getPos()
            trials_2.addData('rmdiff', rmdiff)
            trials_2.addData('feedback_net_posx_begin', feedback_net_posx)
            trials_2.addData('feedback_net_posx_end',  mouse_2.getPos()[0])
            
            #For score
            
            if feedback_color == "green":
                gains = gains+(100)
            else:
                gains=gains
            score_text_2.setAutoDraw(True)
            trials_2.addData('gains', gains)
            
            #For target left on screen
            #target_color = "white"
            #target_coin_2.setAutoDraw(True)
            #trials_2.addData('mouse_previous',mouse_previous )
            trials_2.addData('score_text_2.started', score_text_2.tStartRefresh)
            trials_2.addData('score_text_2.stopped', score_text_2.tStopRefresh)
            # the Routine "cond1_trial_2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_2'
        
        
        # ------Prepare to start Routine "BreakScreen"-------
        continueRoutine = True
        # update component parameters for each repeat
        break_resp.keys = []
        break_resp.rt = []
        _break_resp_allKeys = []
        # keep track of which components have finished
        BreakScreenComponents = [break_text, break_resp]
        for thisComponent in BreakScreenComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        BreakScreenClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "BreakScreen"-------
        while continueRoutine:
            # get current time
            t = BreakScreenClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=BreakScreenClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *break_text* updates
            if break_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                break_text.frameNStart = frameN  # exact frame index
                break_text.tStart = t  # local t and not account for scr refresh
                break_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(break_text, 'tStartRefresh')  # time at next scr refresh
                break_text.setAutoDraw(True)
            
            # *break_resp* updates
            waitOnFlip = False
            if break_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                break_resp.frameNStart = frameN  # exact frame index
                break_resp.tStart = t  # local t and not account for scr refresh
                break_resp.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(break_resp, 'tStartRefresh')  # time at next scr refresh
                break_resp.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(break_resp.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(break_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if break_resp.status == STARTED and not waitOnFlip:
                theseKeys = break_resp.getKeys(keyList=['space', 'space'], waitRelease=False)
                _break_resp_allKeys.extend(theseKeys)
                if len(_break_resp_allKeys):
                    break_resp.keys = _break_resp_allKeys[-1].name  # just the last key pressed
                    break_resp.rt = _break_resp_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in BreakScreenComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "BreakScreen"-------
        for thisComponent in BreakScreenComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        conditions_1and2.addData('break_text.started', break_text.tStartRefresh)
        conditions_1and2.addData('break_text.stopped', break_text.tStopRefresh)
        # check responses
        if break_resp.keys in ['', [], None]:  # No response was made
            break_resp.keys = None
        conditions_1and2.addData('break_resp.keys',break_resp.keys)
        if break_resp.keys != None:  # we had a response
            conditions_1and2.addData('break_resp.rt', break_resp.rt)
        conditions_1and2.addData('break_resp.started', break_resp.tStartRefresh)
        conditions_1and2.addData('break_resp.stopped', break_resp.tStopRefresh)
        # the Routine "BreakScreen" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        trials_7 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond6Trial1),
            seed=None, name='trials_7')
        thisExp.addLoop(trials_7)  # add the loop to the experiment
        thisTrial_7 = trials_7.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_7.rgb)
        if thisTrial_7 != None:
            for paramName in thisTrial_7:
                exec('{} = thisTrial_7[paramName]'.format(paramName))
        
        for thisTrial_7 in trials_7:
            currentLoop = trials_7
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_7.rgb)
            if thisTrial_7 != None:
                for paramName in thisTrial_7:
                    exec('{} = thisTrial_7[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond2_trial1"-------
            continueRoutine = True
            # update component parameters for each repeat
            cue_coin_3.setPos((cue_coin_posx, cue_coin_posy))
            # setup some python lists for storing info about the mouse_4
            gotValidClick = False  # until a click is received
            confirm_net_3.keys = []
            confirm_net_3.rt = []
            _confirm_net_3_allKeys = []
            net_shape_3.setPos((net_posx, net_posy))
            # keep track of which components have finished
            cond2_trial1Components = [cue_coin_3, mouse_4, confirm_net_3, fixation_3, net_shape_3]
            for thisComponent in cond2_trial1Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond2_trial1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond2_trial1"-------
            while continueRoutine:
                # get current time
                t = cond2_trial1Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond2_trial1Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *cue_coin_3* updates
                if cue_coin_3.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_3.frameNStart = frameN  # exact frame index
                    cue_coin_3.tStart = t  # local t and not account for scr refresh
                    cue_coin_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_3, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_3.setAutoDraw(True)
                if cue_coin_3.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_3.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_3.tStop = t  # not accounting for scr refresh
                        cue_coin_3.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_3, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_3.setAutoDraw(False)
                
                # *confirm_net_3* updates
                waitOnFlip = False
                if confirm_net_3.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_3.frameNStart = frameN  # exact frame index
                    confirm_net_3.tStart = t  # local t and not account for scr refresh
                    confirm_net_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_3, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_3.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_3.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_3.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_3.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_3.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_3_allKeys.extend(theseKeys)
                    if len(_confirm_net_3_allKeys):
                        confirm_net_3.keys = _confirm_net_3_allKeys[-1].name  # just the last key pressed
                        confirm_net_3.rt = _confirm_net_3_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *fixation_3* updates
                if fixation_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_3.frameNStart = frameN  # exact frame index
                    fixation_3.tStart = t  # local t and not account for scr refresh
                    fixation_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_3, 'tStartRefresh')  # time at next scr refresh
                    fixation_3.setAutoDraw(True)
                if fixation_3.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_3.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_3.tStop = t  # not accounting for scr refresh
                        fixation_3.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_3, 'tStopRefresh')  # time at next scr refresh
                        fixation_3.setAutoDraw(False)
                net_shape_3.pos = mouse_4.getPos()
                
                # *net_shape_3* updates
                if net_shape_3.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_3.frameNStart = frameN  # exact frame index
                    net_shape_3.tStart = t  # local t and not account for scr refresh
                    net_shape_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_3, 'tStartRefresh')  # time at next scr refresh
                    net_shape_3.setAutoDraw(True)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond2_trial1Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond2_trial1"-------
            for thisComponent in cond2_trial1Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_7.addData('participant', participant)
            trials_7.addData('condition', condition)
            trials_7.addData('cue SD', cueSD)
            trials_7.addData('walk SD', walkSD)
            trials_7.finished = True
            # store data for trials_7 (TrialHandler)
            x, y = mouse_4.getPos()
            buttons = mouse_4.getPressed()
            trials_7.addData('mouse_4.x', x)
            trials_7.addData('mouse_4.y', y)
            trials_7.addData('mouse_4.leftButton', buttons[0])
            trials_7.addData('mouse_4.midButton', buttons[1])
            trials_7.addData('mouse_4.rightButton', buttons[2])
            # check responses
            if confirm_net_3.keys in ['', [], None]:  # No response was made
                confirm_net_3.keys = None
            trials_7.addData('confirm_net_3.keys',confirm_net_3.keys)
            if confirm_net_3.keys != None:  # we had a response
                trials_7.addData('confirm_net_3.rt', confirm_net_3.rt)
            # the Routine "cond2_trial1" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_7'
        
        
        # set up handler to look after randomisation of conditions etc
        trials_3 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond6Trial2andBeyond),
            seed=None, name='trials_3')
        thisExp.addLoop(trials_3)  # add the loop to the experiment
        thisTrial_3 = trials_3.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
        if thisTrial_3 != None:
            for paramName in thisTrial_3:
                exec('{} = thisTrial_3[paramName]'.format(paramName))
        
        for thisTrial_3 in trials_3:
            currentLoop = trials_3
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
            if thisTrial_3 != None:
                for paramName in thisTrial_3:
                    exec('{} = thisTrial_3[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond2_trial_2"-------
            continueRoutine = True
            # update component parameters for each repeat
            target_coin_4.setPos((target_coin_posx2, target_coin_posy2))
            cue_coin_4.setPos((cue_coin_posx2, cue_coin_posy2))
            net_shape_4.setPos((net_posx2, net_posy2))
            # setup some python lists for storing info about the mouse_5
            mouse_5.clicked_name = []
            gotValidClick = False  # until a click is received
            confirm_net_4.keys = []
            confirm_net_4.rt = []
            _confirm_net_4_allKeys = []
            net_shape_feedback_2.setPos((feedback_net_posx, feedback_net_posy))
            score_text_3.setText(gains)
            # keep track of which components have finished
            cond2_trial_2Components = [target_coin_4, cue_coin_4, net_shape_4, mouse_5, fixation_4, confirm_net_4, net_shape_feedback_2, score_text_3]
            for thisComponent in cond2_trial_2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond2_trial_2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond2_trial_2"-------
            while continueRoutine:
                # get current time
                t = cond2_trial_2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond2_trial_2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *target_coin_4* updates
                if target_coin_4.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    target_coin_4.frameNStart = frameN  # exact frame index
                    target_coin_4.tStart = t  # local t and not account for scr refresh
                    target_coin_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(target_coin_4, 'tStartRefresh')  # time at next scr refresh
                    target_coin_4.setAutoDraw(True)
                if target_coin_4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > target_coin_4.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        target_coin_4.tStop = t  # not accounting for scr refresh
                        target_coin_4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(target_coin_4, 'tStopRefresh')  # time at next scr refresh
                        target_coin_4.setAutoDraw(False)
                
                # *cue_coin_4* updates
                if cue_coin_4.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_4.frameNStart = frameN  # exact frame index
                    cue_coin_4.tStart = t  # local t and not account for scr refresh
                    cue_coin_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_4, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_4.setAutoDraw(True)
                if cue_coin_4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_4.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_4.tStop = t  # not accounting for scr refresh
                        cue_coin_4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_4, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_4.setAutoDraw(False)
                net_shape_4.pos = mouse_5.getPos()
                
                # *net_shape_4* updates
                if net_shape_4.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_4.frameNStart = frameN  # exact frame index
                    net_shape_4.tStart = t  # local t and not account for scr refresh
                    net_shape_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_4, 'tStartRefresh')  # time at next scr refresh
                    net_shape_4.setAutoDraw(True)
                
                # *fixation_4* updates
                if fixation_4.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_4.frameNStart = frameN  # exact frame index
                    fixation_4.tStart = t  # local t and not account for scr refresh
                    fixation_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_4, 'tStartRefresh')  # time at next scr refresh
                    fixation_4.setAutoDraw(True)
                if fixation_4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_4.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_4.tStop = t  # not accounting for scr refresh
                        fixation_4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_4, 'tStopRefresh')  # time at next scr refresh
                        fixation_4.setAutoDraw(False)
                
                # *confirm_net_4* updates
                waitOnFlip = False
                if confirm_net_4.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_4.frameNStart = frameN  # exact frame index
                    confirm_net_4.tStart = t  # local t and not account for scr refresh
                    confirm_net_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_4, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_4.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_4.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_4.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_4.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_4.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_4_allKeys.extend(theseKeys)
                    if len(_confirm_net_4_allKeys):
                        confirm_net_4.keys = _confirm_net_4_allKeys[-1].name  # just the last key pressed
                        confirm_net_4.rt = _confirm_net_4_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                net_shape_feedback_2.pos = mouse_5.getPos()
                
                
                target = target_coin_posx2
                difference = target - mouse_5.getPos()[0]
                rmdiff = sqrt(difference**2)
                
                    
                if rmdiff  < 0.05:
                    feedback_color = "green"
                    net_shape_feedback_2.opacity = 0.7
                else:
                    feedback_color = "white"
                    net_shape_feedback_2.opacity = 0.7
                
                # *net_shape_feedback_2* updates
                if net_shape_feedback_2.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_feedback_2.frameNStart = frameN  # exact frame index
                    net_shape_feedback_2.tStart = t  # local t and not account for scr refresh
                    net_shape_feedback_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_feedback_2, 'tStartRefresh')  # time at next scr refresh
                    net_shape_feedback_2.setAutoDraw(True)
                if net_shape_feedback_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > net_shape_feedback_2.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        net_shape_feedback_2.tStop = t  # not accounting for scr refresh
                        net_shape_feedback_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(net_shape_feedback_2, 'tStopRefresh')  # time at next scr refresh
                        net_shape_feedback_2.setAutoDraw(False)
                if net_shape_feedback_2.status == STARTED:  # only update if drawing
                    net_shape_feedback_2.setFillColor(feedback_color)
                    net_shape_feedback_2.setLineColor(border_color)
                
                # *score_text_3* updates
                if score_text_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    score_text_3.frameNStart = frameN  # exact frame index
                    score_text_3.tStart = t  # local t and not account for scr refresh
                    score_text_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(score_text_3, 'tStartRefresh')  # time at next scr refresh
                    score_text_3.setAutoDraw(True)
                if score_text_3.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > score_text_3.tStartRefresh + 1.0-frameTolerance:
                        # keep track of stop time/frame for later
                        score_text_3.tStop = t  # not accounting for scr refresh
                        score_text_3.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(score_text_3, 'tStopRefresh')  # time at next scr refresh
                        score_text_3.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond2_trial_2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond2_trial_2"-------
            for thisComponent in cond2_trial_2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_3.addData('participant', participant)
            trials_3.addData('condition', condition)
            trials_3.addData('cue SD', cueSD)
            trials_3.addData('walk SD', walkSD)
            conditions_1and2.finished = True
            # store data for trials_3 (TrialHandler)
            x, y = mouse_5.getPos()
            buttons = mouse_5.getPressed()
            if sum(buttons):
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [net_shape]:
                    if obj.contains(mouse_5):
                        gotValidClick = True
                        mouse_5.clicked_name.append(obj.name)
            trials_3.addData('mouse_5.x', x)
            trials_3.addData('mouse_5.y', y)
            trials_3.addData('mouse_5.leftButton', buttons[0])
            trials_3.addData('mouse_5.midButton', buttons[1])
            trials_3.addData('mouse_5.rightButton', buttons[2])
            if len(mouse_5.clicked_name):
                trials_3.addData('mouse_5.clicked_name', mouse_5.clicked_name[0])
            trials_3.addData('fixation_4.started', fixation_4.tStartRefresh)
            trials_3.addData('fixation_4.stopped', fixation_4.tStopRefresh)
            # check responses
            if confirm_net_4.keys in ['', [], None]:  # No response was made
                confirm_net_4.keys = None
            trials_3.addData('confirm_net_4.keys',confirm_net_4.keys)
            if confirm_net_4.keys != None:  # we had a response
                trials_3.addData('confirm_net_4.rt', confirm_net_4.rt)
            trials_3.addData('rmdiff', rmdiff)
            trials_3.addData('score_text_3.started', score_text_3.tStartRefresh)
            trials_3.addData('score_text_3.stopped', score_text_3.tStopRefresh)
            # the Routine "cond2_trial_2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_3'
        
        thisExp.nextEntry()
        
    # completed nRepsTask1 repeats of 'conditions_1and2'
    
    
    # set up handler to look after randomisation of conditions etc
    conditions_3and4 = data.TrialHandler(nReps=nRepsTask2, method='random', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions('cueSD0.15_0.2.xlsx'),
        seed=None, name='conditions_3and4')
    thisExp.addLoop(conditions_3and4)  # add the loop to the experiment
    thisConditions_3and4 = conditions_3and4.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisConditions_3and4.rgb)
    if thisConditions_3and4 != None:
        for paramName in thisConditions_3and4:
            exec('{} = thisConditions_3and4[paramName]'.format(paramName))
    
    for thisConditions_3and4 in conditions_3and4:
        currentLoop = conditions_3and4
        # abbreviate parameter names if possible (e.g. rgb = thisConditions_3and4.rgb)
        if thisConditions_3and4 != None:
            for paramName in thisConditions_3and4:
                exec('{} = thisConditions_3and4[paramName]'.format(paramName))
        
        # set up handler to look after randomisation of conditions etc
        trials_4 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond3Trial1),
            seed=None, name='trials_4')
        thisExp.addLoop(trials_4)  # add the loop to the experiment
        thisTrial_4 = trials_4.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
        if thisTrial_4 != None:
            for paramName in thisTrial_4:
                exec('{} = thisTrial_4[paramName]'.format(paramName))
        
        for thisTrial_4 in trials_4:
            currentLoop = trials_4
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
            if thisTrial_4 != None:
                for paramName in thisTrial_4:
                    exec('{} = thisTrial_4[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "condition_order2"-------
            continueRoutine = True
            # update component parameters for each repeat
            text_7.setText(condition2)
            key_resp_2.keys = []
            key_resp_2.rt = []
            _key_resp_2_allKeys = []
            if int(expInfo['participant'])%2==0:
                group = 'AB'
                condition1 = 'Press space to begin the first condition'
                condition2 = 'Press space to begin the second condition' +'\n'+'Have a short break if needed'
            else:
                group = 'BA'
                condition1 = 'Press space to begin the second condition' +'\n'+'Have a short break if needed'
                condition2 = 'Press space to begin the first condition'
            # keep track of which components have finished
            condition_order2Components = [text_7, key_resp_2]
            for thisComponent in condition_order2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            condition_order2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "condition_order2"-------
            while continueRoutine:
                # get current time
                t = condition_order2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=condition_order2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *text_7* updates
                if text_7.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    text_7.frameNStart = frameN  # exact frame index
                    text_7.tStart = t  # local t and not account for scr refresh
                    text_7.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(text_7, 'tStartRefresh')  # time at next scr refresh
                    text_7.setAutoDraw(True)
                
                # *key_resp_2* updates
                waitOnFlip = False
                if key_resp_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_resp_2.frameNStart = frameN  # exact frame index
                    key_resp_2.tStart = t  # local t and not account for scr refresh
                    key_resp_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_resp_2, 'tStartRefresh')  # time at next scr refresh
                    key_resp_2.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_resp_2.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_resp_2.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_resp_2.status == STARTED and not waitOnFlip:
                    theseKeys = key_resp_2.getKeys(keyList=['space'], waitRelease=False)
                    _key_resp_2_allKeys.extend(theseKeys)
                    if len(_key_resp_2_allKeys):
                        key_resp_2.keys = _key_resp_2_allKeys[-1].name  # just the last key pressed
                        key_resp_2.rt = _key_resp_2_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in condition_order2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "condition_order2"-------
            for thisComponent in condition_order2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            trials_4.addData('text_7.started', text_7.tStartRefresh)
            trials_4.addData('text_7.stopped', text_7.tStopRefresh)
            # check responses
            if key_resp_2.keys in ['', [], None]:  # No response was made
                key_resp_2.keys = None
            trials_4.addData('key_resp_2.keys',key_resp_2.keys)
            if key_resp_2.keys != None:  # we had a response
                trials_4.addData('key_resp_2.rt', key_resp_2.rt)
            trials_4.addData('key_resp_2.started', key_resp_2.tStartRefresh)
            trials_4.addData('key_resp_2.stopped', key_resp_2.tStopRefresh)
            # the Routine "condition_order2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            
            # ------Prepare to start Routine "cond3_trial1"-------
            continueRoutine = True
            # update component parameters for each repeat
            cue_coin_5.setPos((cue_coin_posx, cue_coin_posy))
            # setup some python lists for storing info about the mouse_6
            gotValidClick = False  # until a click is received
            confirm_net_6.keys = []
            confirm_net_6.rt = []
            _confirm_net_6_allKeys = []
            net_shape_5.setPos((net_posx, net_posy))
            # keep track of which components have finished
            cond3_trial1Components = [cue_coin_5, mouse_6, confirm_net_6, fixation_5, net_shape_5]
            for thisComponent in cond3_trial1Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond3_trial1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond3_trial1"-------
            while continueRoutine:
                # get current time
                t = cond3_trial1Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond3_trial1Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *cue_coin_5* updates
                if cue_coin_5.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_5.frameNStart = frameN  # exact frame index
                    cue_coin_5.tStart = t  # local t and not account for scr refresh
                    cue_coin_5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_5, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_5.setAutoDraw(True)
                if cue_coin_5.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_5.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_5.tStop = t  # not accounting for scr refresh
                        cue_coin_5.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_5, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_5.setAutoDraw(False)
                
                # *confirm_net_6* updates
                waitOnFlip = False
                if confirm_net_6.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_6.frameNStart = frameN  # exact frame index
                    confirm_net_6.tStart = t  # local t and not account for scr refresh
                    confirm_net_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_6, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_6.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_6.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_6.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_6.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_6.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_6_allKeys.extend(theseKeys)
                    if len(_confirm_net_6_allKeys):
                        confirm_net_6.keys = _confirm_net_6_allKeys[-1].name  # just the last key pressed
                        confirm_net_6.rt = _confirm_net_6_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *fixation_5* updates
                if fixation_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_5.frameNStart = frameN  # exact frame index
                    fixation_5.tStart = t  # local t and not account for scr refresh
                    fixation_5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_5, 'tStartRefresh')  # time at next scr refresh
                    fixation_5.setAutoDraw(True)
                if fixation_5.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_5.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_5.tStop = t  # not accounting for scr refresh
                        fixation_5.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_5, 'tStopRefresh')  # time at next scr refresh
                        fixation_5.setAutoDraw(False)
                net_shape_5.pos = mouse_6.getPos()
                
                # *net_shape_5* updates
                if net_shape_5.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_5.frameNStart = frameN  # exact frame index
                    net_shape_5.tStart = t  # local t and not account for scr refresh
                    net_shape_5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_5, 'tStartRefresh')  # time at next scr refresh
                    net_shape_5.setAutoDraw(True)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond3_trial1Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond3_trial1"-------
            for thisComponent in cond3_trial1Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_4.addData('participant', participant)
            trials_4.addData('condition', condition)
            trials_4.addData('cue SD', cueSD)
            trials_4.addData('walk SD', walkSD)
            trials_4.finished = True
            # store data for trials_4 (TrialHandler)
            x, y = mouse_6.getPos()
            buttons = mouse_6.getPressed()
            trials_4.addData('mouse_6.x', x)
            trials_4.addData('mouse_6.y', y)
            trials_4.addData('mouse_6.leftButton', buttons[0])
            trials_4.addData('mouse_6.midButton', buttons[1])
            trials_4.addData('mouse_6.rightButton', buttons[2])
            # check responses
            if confirm_net_6.keys in ['', [], None]:  # No response was made
                confirm_net_6.keys = None
            trials_4.addData('confirm_net_6.keys',confirm_net_6.keys)
            if confirm_net_6.keys != None:  # we had a response
                trials_4.addData('confirm_net_6.rt', confirm_net_6.rt)
            trials_4.addData('fixation_5.started', fixation_5.tStartRefresh)
            trials_4.addData('fixation_5.stopped', fixation_5.tStopRefresh)
            # the Routine "cond3_trial1" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_4'
        
        
        # set up handler to look after randomisation of conditions etc
        trials_5 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond3Trial2andBeyond),
            seed=None, name='trials_5')
        thisExp.addLoop(trials_5)  # add the loop to the experiment
        thisTrial_5 = trials_5.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
        if thisTrial_5 != None:
            for paramName in thisTrial_5:
                exec('{} = thisTrial_5[paramName]'.format(paramName))
        
        for thisTrial_5 in trials_5:
            currentLoop = trials_5
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
            if thisTrial_5 != None:
                for paramName in thisTrial_5:
                    exec('{} = thisTrial_5[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond3_trial2"-------
            continueRoutine = True
            # update component parameters for each repeat
            target_coin_6.setPos((target_coin_posx2, target_coin_posy2))
            cue_coin_6.setPos((cue_coin_posx2, cue_coin_posy2))
            net_shape_6.setPos((net_posx2, net_posy2))
            # setup some python lists for storing info about the mouse_7
            mouse_7.clicked_name = []
            gotValidClick = False  # until a click is received
            confirm_net_5.keys = []
            confirm_net_5.rt = []
            _confirm_net_5_allKeys = []
            net_shape_feedback_3.setPos((feedback_net_posx, feedback_net_posy))
            score_text_4.setText(gains)
            # keep track of which components have finished
            cond3_trial2Components = [target_coin_6, cue_coin_6, net_shape_6, mouse_7, fixation_6, confirm_net_5, net_shape_feedback_3, score_text_4]
            for thisComponent in cond3_trial2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond3_trial2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond3_trial2"-------
            while continueRoutine:
                # get current time
                t = cond3_trial2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond3_trial2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *target_coin_6* updates
                if target_coin_6.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    target_coin_6.frameNStart = frameN  # exact frame index
                    target_coin_6.tStart = t  # local t and not account for scr refresh
                    target_coin_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(target_coin_6, 'tStartRefresh')  # time at next scr refresh
                    target_coin_6.setAutoDraw(True)
                if target_coin_6.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > target_coin_6.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        target_coin_6.tStop = t  # not accounting for scr refresh
                        target_coin_6.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(target_coin_6, 'tStopRefresh')  # time at next scr refresh
                        target_coin_6.setAutoDraw(False)
                
                # *cue_coin_6* updates
                if cue_coin_6.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_6.frameNStart = frameN  # exact frame index
                    cue_coin_6.tStart = t  # local t and not account for scr refresh
                    cue_coin_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_6, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_6.setAutoDraw(True)
                if cue_coin_6.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_6.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_6.tStop = t  # not accounting for scr refresh
                        cue_coin_6.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_6, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_6.setAutoDraw(False)
                net_shape_6.pos = mouse_7.getPos()
                
                # *net_shape_6* updates
                if net_shape_6.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_6.frameNStart = frameN  # exact frame index
                    net_shape_6.tStart = t  # local t and not account for scr refresh
                    net_shape_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_6, 'tStartRefresh')  # time at next scr refresh
                    net_shape_6.setAutoDraw(True)
                
                # *fixation_6* updates
                if fixation_6.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_6.frameNStart = frameN  # exact frame index
                    fixation_6.tStart = t  # local t and not account for scr refresh
                    fixation_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_6, 'tStartRefresh')  # time at next scr refresh
                    fixation_6.setAutoDraw(True)
                if fixation_6.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_6.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_6.tStop = t  # not accounting for scr refresh
                        fixation_6.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_6, 'tStopRefresh')  # time at next scr refresh
                        fixation_6.setAutoDraw(False)
                
                # *confirm_net_5* updates
                waitOnFlip = False
                if confirm_net_5.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_5.frameNStart = frameN  # exact frame index
                    confirm_net_5.tStart = t  # local t and not account for scr refresh
                    confirm_net_5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_5, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_5.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_5.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_5.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_5.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_5.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_5_allKeys.extend(theseKeys)
                    if len(_confirm_net_5_allKeys):
                        confirm_net_5.keys = _confirm_net_5_allKeys[-1].name  # just the last key pressed
                        confirm_net_5.rt = _confirm_net_5_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                net_shape_feedback_3.pos = mouse_7.getPos()
                
                target = target_coin_posx2
                difference = target - mouse_7.getPos()[0]
                rmdiff = sqrt(difference**2)
                
                    
                if rmdiff  < 0.05:
                    feedback_color = "white"
                    border_color = "white"
                    net_shape_feedback_3.opacity = 0.7
                else:
                    feedback_color = "white"
                    border_color = "white"
                    net_shape_feedback_3.opacity = 0.7
                
                # *net_shape_feedback_3* updates
                if net_shape_feedback_3.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_feedback_3.frameNStart = frameN  # exact frame index
                    net_shape_feedback_3.tStart = t  # local t and not account for scr refresh
                    net_shape_feedback_3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_feedback_3, 'tStartRefresh')  # time at next scr refresh
                    net_shape_feedback_3.setAutoDraw(True)
                if net_shape_feedback_3.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > net_shape_feedback_3.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        net_shape_feedback_3.tStop = t  # not accounting for scr refresh
                        net_shape_feedback_3.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(net_shape_feedback_3, 'tStopRefresh')  # time at next scr refresh
                        net_shape_feedback_3.setAutoDraw(False)
                if net_shape_feedback_3.status == STARTED:  # only update if drawing
                    net_shape_feedback_3.setFillColor(feedback_color)
                    net_shape_feedback_3.setLineColor(border_color)
                
                # *score_text_4* updates
                if score_text_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    score_text_4.frameNStart = frameN  # exact frame index
                    score_text_4.tStart = t  # local t and not account for scr refresh
                    score_text_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(score_text_4, 'tStartRefresh')  # time at next scr refresh
                    score_text_4.setAutoDraw(True)
                if score_text_4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > score_text_4.tStartRefresh + 1.0-frameTolerance:
                        # keep track of stop time/frame for later
                        score_text_4.tStop = t  # not accounting for scr refresh
                        score_text_4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(score_text_4, 'tStopRefresh')  # time at next scr refresh
                        score_text_4.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond3_trial2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond3_trial2"-------
            for thisComponent in cond3_trial2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_5.addData('participant', participant)
            trials_5.addData('condition', condition)
            trials_5.addData('cue SD', cueSD)
            trials_5.addData('walk SD', walkSD)
            # store data for trials_5 (TrialHandler)
            x, y = mouse_7.getPos()
            buttons = mouse_7.getPressed()
            if sum(buttons):
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [net_shape]:
                    if obj.contains(mouse_7):
                        gotValidClick = True
                        mouse_7.clicked_name.append(obj.name)
            trials_5.addData('mouse_7.x', x)
            trials_5.addData('mouse_7.y', y)
            trials_5.addData('mouse_7.leftButton', buttons[0])
            trials_5.addData('mouse_7.midButton', buttons[1])
            trials_5.addData('mouse_7.rightButton', buttons[2])
            if len(mouse_7.clicked_name):
                trials_5.addData('mouse_7.clicked_name', mouse_7.clicked_name[0])
            trials_5.addData('fixation_6.started', fixation_6.tStartRefresh)
            trials_5.addData('fixation_6.stopped', fixation_6.tStopRefresh)
            # check responses
            if confirm_net_5.keys in ['', [], None]:  # No response was made
                confirm_net_5.keys = None
            trials_5.addData('confirm_net_5.keys',confirm_net_5.keys)
            if confirm_net_5.keys != None:  # we had a response
                trials_5.addData('confirm_net_5.rt', confirm_net_5.rt)
            trials_5.addData("rmdiff", rmdiff)
            trials_5.addData('score_text_4.started', score_text_4.tStartRefresh)
            trials_5.addData('score_text_4.stopped', score_text_4.tStopRefresh)
            # the Routine "cond3_trial2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_5'
        
        
        # ------Prepare to start Routine "BreakScreen"-------
        continueRoutine = True
        # update component parameters for each repeat
        break_resp.keys = []
        break_resp.rt = []
        _break_resp_allKeys = []
        # keep track of which components have finished
        BreakScreenComponents = [break_text, break_resp]
        for thisComponent in BreakScreenComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        BreakScreenClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "BreakScreen"-------
        while continueRoutine:
            # get current time
            t = BreakScreenClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=BreakScreenClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *break_text* updates
            if break_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                break_text.frameNStart = frameN  # exact frame index
                break_text.tStart = t  # local t and not account for scr refresh
                break_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(break_text, 'tStartRefresh')  # time at next scr refresh
                break_text.setAutoDraw(True)
            
            # *break_resp* updates
            waitOnFlip = False
            if break_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                break_resp.frameNStart = frameN  # exact frame index
                break_resp.tStart = t  # local t and not account for scr refresh
                break_resp.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(break_resp, 'tStartRefresh')  # time at next scr refresh
                break_resp.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(break_resp.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(break_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if break_resp.status == STARTED and not waitOnFlip:
                theseKeys = break_resp.getKeys(keyList=['space', 'space'], waitRelease=False)
                _break_resp_allKeys.extend(theseKeys)
                if len(_break_resp_allKeys):
                    break_resp.keys = _break_resp_allKeys[-1].name  # just the last key pressed
                    break_resp.rt = _break_resp_allKeys[-1].rt
                    # a response ends the routine
                    continueRoutine = False
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in BreakScreenComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "BreakScreen"-------
        for thisComponent in BreakScreenComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        conditions_3and4.addData('break_text.started', break_text.tStartRefresh)
        conditions_3and4.addData('break_text.stopped', break_text.tStopRefresh)
        # check responses
        if break_resp.keys in ['', [], None]:  # No response was made
            break_resp.keys = None
        conditions_3and4.addData('break_resp.keys',break_resp.keys)
        if break_resp.keys != None:  # we had a response
            conditions_3and4.addData('break_resp.rt', break_resp.rt)
        conditions_3and4.addData('break_resp.started', break_resp.tStartRefresh)
        conditions_3and4.addData('break_resp.stopped', break_resp.tStopRefresh)
        # the Routine "BreakScreen" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        trials_6 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond4Trial1),
            seed=None, name='trials_6')
        thisExp.addLoop(trials_6)  # add the loop to the experiment
        thisTrial_6 = trials_6.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
        if thisTrial_6 != None:
            for paramName in thisTrial_6:
                exec('{} = thisTrial_6[paramName]'.format(paramName))
        
        for thisTrial_6 in trials_6:
            currentLoop = trials_6
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
            if thisTrial_6 != None:
                for paramName in thisTrial_6:
                    exec('{} = thisTrial_6[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond4_trial1"-------
            continueRoutine = True
            # update component parameters for each repeat
            cue_coin_7.setPos((cue_coin_posx, cue_coin_posy))
            # setup some python lists for storing info about the mouse_8
            gotValidClick = False  # until a click is received
            confirm_net_7.keys = []
            confirm_net_7.rt = []
            _confirm_net_7_allKeys = []
            net_shape_7.setPos((net_posx, net_posy))
            # keep track of which components have finished
            cond4_trial1Components = [cue_coin_7, mouse_8, confirm_net_7, fixation_7, net_shape_7]
            for thisComponent in cond4_trial1Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond4_trial1Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond4_trial1"-------
            while continueRoutine:
                # get current time
                t = cond4_trial1Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond4_trial1Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *cue_coin_7* updates
                if cue_coin_7.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_7.frameNStart = frameN  # exact frame index
                    cue_coin_7.tStart = t  # local t and not account for scr refresh
                    cue_coin_7.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_7, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_7.setAutoDraw(True)
                if cue_coin_7.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_7.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_7.tStop = t  # not accounting for scr refresh
                        cue_coin_7.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_7, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_7.setAutoDraw(False)
                
                # *confirm_net_7* updates
                waitOnFlip = False
                if confirm_net_7.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_7.frameNStart = frameN  # exact frame index
                    confirm_net_7.tStart = t  # local t and not account for scr refresh
                    confirm_net_7.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_7, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_7.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_7.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_7.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_7.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_7.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_7_allKeys.extend(theseKeys)
                    if len(_confirm_net_7_allKeys):
                        confirm_net_7.keys = _confirm_net_7_allKeys[-1].name  # just the last key pressed
                        confirm_net_7.rt = _confirm_net_7_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                
                # *fixation_7* updates
                if fixation_7.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_7.frameNStart = frameN  # exact frame index
                    fixation_7.tStart = t  # local t and not account for scr refresh
                    fixation_7.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_7, 'tStartRefresh')  # time at next scr refresh
                    fixation_7.setAutoDraw(True)
                if fixation_7.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_7.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_7.tStop = t  # not accounting for scr refresh
                        fixation_7.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_7, 'tStopRefresh')  # time at next scr refresh
                        fixation_7.setAutoDraw(False)
                net_shape_7.pos = mouse_8.getPos()
                
                # *net_shape_7* updates
                if net_shape_7.status == NOT_STARTED and tThisFlip >= 1.0-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_7.frameNStart = frameN  # exact frame index
                    net_shape_7.tStart = t  # local t and not account for scr refresh
                    net_shape_7.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_7, 'tStartRefresh')  # time at next scr refresh
                    net_shape_7.setAutoDraw(True)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond4_trial1Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond4_trial1"-------
            for thisComponent in cond4_trial1Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_6.addData('participant', participant)
            trials_6.addData('condition', condition)
            trials_6.addData('cue SD', cueSD)
            trials_6.addData('walk SD', walkSD)
            trials_6.finished = True
            # store data for trials_6 (TrialHandler)
            x, y = mouse_8.getPos()
            buttons = mouse_8.getPressed()
            trials_6.addData('mouse_8.x', x)
            trials_6.addData('mouse_8.y', y)
            trials_6.addData('mouse_8.leftButton', buttons[0])
            trials_6.addData('mouse_8.midButton', buttons[1])
            trials_6.addData('mouse_8.rightButton', buttons[2])
            # check responses
            if confirm_net_7.keys in ['', [], None]:  # No response was made
                confirm_net_7.keys = None
            trials_6.addData('confirm_net_7.keys',confirm_net_7.keys)
            if confirm_net_7.keys != None:  # we had a response
                trials_6.addData('confirm_net_7.rt', confirm_net_7.rt)
            trials_6.addData('fixation_7.started', fixation_7.tStartRefresh)
            trials_6.addData('fixation_7.stopped', fixation_7.tStopRefresh)
            # the Routine "cond4_trial1" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_6'
        
        
        # set up handler to look after randomisation of conditions etc
        trials_9 = data.TrialHandler(nReps=1, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Cond4Trial2andBeyond),
            seed=None, name='trials_9')
        thisExp.addLoop(trials_9)  # add the loop to the experiment
        thisTrial_9 = trials_9.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_9.rgb)
        if thisTrial_9 != None:
            for paramName in thisTrial_9:
                exec('{} = thisTrial_9[paramName]'.format(paramName))
        
        for thisTrial_9 in trials_9:
            currentLoop = trials_9
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_9.rgb)
            if thisTrial_9 != None:
                for paramName in thisTrial_9:
                    exec('{} = thisTrial_9[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "cond4_trial2"-------
            continueRoutine = True
            # update component parameters for each repeat
            target_coin_8.setPos((target_coin_posx2, target_coin_posy2))
            cue_coin_8.setPos((cue_coin_posx2, cue_coin_posy2))
            net_shape_8.setPos((net_posx2, net_posy2))
            # setup some python lists for storing info about the mouse_9
            mouse_9.clicked_name = []
            gotValidClick = False  # until a click is received
            confirm_net_8.keys = []
            confirm_net_8.rt = []
            _confirm_net_8_allKeys = []
            net_shape_feedback_4.setPos((feedback_net_posx, feedback_net_posy))
            score_text_5.setText(gains)
            # keep track of which components have finished
            cond4_trial2Components = [target_coin_8, cue_coin_8, net_shape_8, mouse_9, fixation_8, confirm_net_8, net_shape_feedback_4, score_text_5]
            for thisComponent in cond4_trial2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            cond4_trial2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "cond4_trial2"-------
            while continueRoutine:
                # get current time
                t = cond4_trial2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=cond4_trial2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *target_coin_8* updates
                if target_coin_8.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    target_coin_8.frameNStart = frameN  # exact frame index
                    target_coin_8.tStart = t  # local t and not account for scr refresh
                    target_coin_8.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(target_coin_8, 'tStartRefresh')  # time at next scr refresh
                    target_coin_8.setAutoDraw(True)
                if target_coin_8.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > target_coin_8.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        target_coin_8.tStop = t  # not accounting for scr refresh
                        target_coin_8.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(target_coin_8, 'tStopRefresh')  # time at next scr refresh
                        target_coin_8.setAutoDraw(False)
                
                # *cue_coin_8* updates
                if cue_coin_8.status == NOT_STARTED and tThisFlip >= 2.0-frameTolerance:
                    # keep track of start time/frame for later
                    cue_coin_8.frameNStart = frameN  # exact frame index
                    cue_coin_8.tStart = t  # local t and not account for scr refresh
                    cue_coin_8.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(cue_coin_8, 'tStartRefresh')  # time at next scr refresh
                    cue_coin_8.setAutoDraw(True)
                if cue_coin_8.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > cue_coin_8.tStartRefresh + 0.3-frameTolerance:
                        # keep track of stop time/frame for later
                        cue_coin_8.tStop = t  # not accounting for scr refresh
                        cue_coin_8.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(cue_coin_8, 'tStopRefresh')  # time at next scr refresh
                        cue_coin_8.setAutoDraw(False)
                net_shape_8.pos = mouse_9.getPos()
                
                # *net_shape_8* updates
                if net_shape_8.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_8.frameNStart = frameN  # exact frame index
                    net_shape_8.tStart = t  # local t and not account for scr refresh
                    net_shape_8.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_8, 'tStartRefresh')  # time at next scr refresh
                    net_shape_8.setAutoDraw(True)
                
                # *fixation_8* updates
                if fixation_8.status == NOT_STARTED and tThisFlip >= 1.5-frameTolerance:
                    # keep track of start time/frame for later
                    fixation_8.frameNStart = frameN  # exact frame index
                    fixation_8.tStart = t  # local t and not account for scr refresh
                    fixation_8.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fixation_8, 'tStartRefresh')  # time at next scr refresh
                    fixation_8.setAutoDraw(True)
                if fixation_8.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fixation_8.tStartRefresh + 0.5-frameTolerance:
                        # keep track of stop time/frame for later
                        fixation_8.tStop = t  # not accounting for scr refresh
                        fixation_8.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fixation_8, 'tStopRefresh')  # time at next scr refresh
                        fixation_8.setAutoDraw(False)
                
                # *confirm_net_8* updates
                waitOnFlip = False
                if confirm_net_8.status == NOT_STARTED and tThisFlip >= 2.5-frameTolerance:
                    # keep track of start time/frame for later
                    confirm_net_8.frameNStart = frameN  # exact frame index
                    confirm_net_8.tStart = t  # local t and not account for scr refresh
                    confirm_net_8.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(confirm_net_8, 'tStartRefresh')  # time at next scr refresh
                    confirm_net_8.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(confirm_net_8.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(confirm_net_8.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if confirm_net_8.status == STARTED and not waitOnFlip:
                    theseKeys = confirm_net_8.getKeys(keyList=['space', 'space'], waitRelease=False)
                    _confirm_net_8_allKeys.extend(theseKeys)
                    if len(_confirm_net_8_allKeys):
                        confirm_net_8.keys = _confirm_net_8_allKeys[-1].name  # just the last key pressed
                        confirm_net_8.rt = _confirm_net_8_allKeys[-1].rt
                        # a response ends the routine
                        continueRoutine = False
                net_shape_feedback_4.pos = mouse_9.getPos()
                
                target = target_coin_posx2
                difference = target - mouse_9.getPos()[0]
                rmdiff = sqrt(difference**2)
                
                    
                if rmdiff  < 0.05:
                    feedback_color = "green"
                    border_color = "green"
                    net_shape_feedback_4.opacity = 0.7
                else:
                    feedback_color = "white"
                    border_color = "white"
                    net_shape_feedback_4.opacity = 0.7
                
                # *net_shape_feedback_4* updates
                if net_shape_feedback_4.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
                    # keep track of start time/frame for later
                    net_shape_feedback_4.frameNStart = frameN  # exact frame index
                    net_shape_feedback_4.tStart = t  # local t and not account for scr refresh
                    net_shape_feedback_4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(net_shape_feedback_4, 'tStartRefresh')  # time at next scr refresh
                    net_shape_feedback_4.setAutoDraw(True)
                if net_shape_feedback_4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > net_shape_feedback_4.tStartRefresh + 0.75-frameTolerance:
                        # keep track of stop time/frame for later
                        net_shape_feedback_4.tStop = t  # not accounting for scr refresh
                        net_shape_feedback_4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(net_shape_feedback_4, 'tStopRefresh')  # time at next scr refresh
                        net_shape_feedback_4.setAutoDraw(False)
                if net_shape_feedback_4.status == STARTED:  # only update if drawing
                    net_shape_feedback_4.setFillColor(feedback_color)
                    net_shape_feedback_4.setLineColor(border_color)
                
                # *score_text_5* updates
                if score_text_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    score_text_5.frameNStart = frameN  # exact frame index
                    score_text_5.tStart = t  # local t and not account for scr refresh
                    score_text_5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(score_text_5, 'tStartRefresh')  # time at next scr refresh
                    score_text_5.setAutoDraw(True)
                if score_text_5.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > score_text_5.tStartRefresh + 1.0-frameTolerance:
                        # keep track of stop time/frame for later
                        score_text_5.tStop = t  # not accounting for scr refresh
                        score_text_5.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(score_text_5, 'tStopRefresh')  # time at next scr refresh
                        score_text_5.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in cond4_trial2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "cond4_trial2"-------
            for thisComponent in cond4_trial2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            participant = expInfo['participant']
            condition = 'Walk'
            cueSD = cue_SD
            walkSD = prior_SD
            trials_9.addData('participant', participant)
            trials_9.addData('condition', condition)
            trials_9.addData('cue SD', cueSD)
            trials_9.addData('walk SD', walkSD)
            conditions_3and4.finished = True
            # store data for trials_9 (TrialHandler)
            x, y = mouse_9.getPos()
            buttons = mouse_9.getPressed()
            if sum(buttons):
                # check if the mouse was inside our 'clickable' objects
                gotValidClick = False
                for obj in [net_shape]:
                    if obj.contains(mouse_9):
                        gotValidClick = True
                        mouse_9.clicked_name.append(obj.name)
            trials_9.addData('mouse_9.x', x)
            trials_9.addData('mouse_9.y', y)
            trials_9.addData('mouse_9.leftButton', buttons[0])
            trials_9.addData('mouse_9.midButton', buttons[1])
            trials_9.addData('mouse_9.rightButton', buttons[2])
            if len(mouse_9.clicked_name):
                trials_9.addData('mouse_9.clicked_name', mouse_9.clicked_name[0])
            trials_9.addData('fixation_8.started', fixation_8.tStartRefresh)
            trials_9.addData('fixation_8.stopped', fixation_8.tStopRefresh)
            # check responses
            if confirm_net_8.keys in ['', [], None]:  # No response was made
                confirm_net_8.keys = None
            trials_9.addData('confirm_net_8.keys',confirm_net_8.keys)
            if confirm_net_8.keys != None:  # we had a response
                trials_9.addData('confirm_net_8.rt', confirm_net_8.rt)
            trials_9.addData("rmdiff", rmdiff)
            trials_9.addData('score_text_5.started', score_text_5.tStartRefresh)
            trials_9.addData('score_text_5.stopped', score_text_5.tStopRefresh)
            # the Routine "cond4_trial2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            thisExp.nextEntry()
            
        # completed 1 repeats of 'trials_9'
        
        thisExp.nextEntry()
        
    # completed nRepsTask2 repeats of 'conditions_3and4'
    
    thisExp.nextEntry()
    
# completed 1.0 repeats of 'controlTaskOrder'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
